#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <string>
#include <string.h>
#include <vector>
#include <ctime>
#include <cassert>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pb push_back
#define y0 askjdfghjksdf
#define y1 askldjfahsd
#define fst first
#define snd second

template<typename T> T abs(T x) {if (x>=0) return x; return -x;}

const int maxn = 100003;
ll mod = 998244353;
ll level[10000];
ll st[maxn];
ll cnt[22];
ll f[22][maxn];
ll fact[maxn];
ll inv[maxn];
ll c[22][maxn];

ll binpow(ll x, ll st)
{
	ll ans = 1;
	while (st)
	{
		if (st & 1)
			ans = (ans * x) % mod;
		x = (x * x) % mod;
		st >>= 1;
	}
	return ans;
}

ll getcomb(ll n, ll k)
{
	return c[n][k];
}

ll rec(int i, int kol)
{
	if (f[i][kol] != -1)
		return f[i][kol];
	if (i == 0)
	{
		if (kol == 0)
			return f[i][kol] = 1;
		return 0;
	}
	ll all = st[cnt[i]];
	ll cur = 0;
	for (int j = 0; j <= kol; j++)
	{
		if (j > cnt[i])
			break;
		cur = (cur + rec(i-1, (kol-j) * 2) * getcomb(i, j)) % mod;
		all -= getcomb(i, j);
	}
	all %= mod;
	if (all < 0)
		all += mod;
	cur = (cur + all * rec(i - 1, 0)) % mod;
	return f[i][kol] = cur;
}

int main()
{
	//freopen("a.in", "r", stdin);
	fact[0] = 1;
	for (int i = 1; i <= 100000; i++)
		fact[i] = (fact[i-1] * i) % mod;
	inv[0] = 1;
	for (int i = 1; i <= 100000; i++)
		inv[i] = binpow(fact[i], mod - 2);

	for (int i = 0; i <= 11; i++)
		level[(1 << i)] = i + 1;
	st[0] = 1;
	for (int i = 1; i <= 100000; i++)
		st[i] = (st[i-1] * 2) % mod;
	while (true)
	{
		int n;
		cin >> n;
		if (n == 0)
			break;
		ll ost = 0;
		for (int i = 1; i <= 12; i++)
			cnt[i] = 0;
		for (int i = 0; i <= 12; i++)
			for (int j = 0; j <= 10000; j++)
				f[i][j] = -1;
		for (int i = 1; i <= n; i++)
		{
			int x;
			scanf("%d", &x);
			if (level[x] == 0)
				ost++;
			else
			{
				cnt[level[x]]++;
			}
		}
		for (int i = 1; i <= 12; i++)
		{
			for (int j = 0; j <= cnt[i]; j++)
			{
				c[i][j] = (((fact[cnt[i]] * inv[j]) % mod * inv[cnt[i] - j]) % mod);
			}
		}
		ll ans = (rec(12, 1) * st[ost]) % mod;
		cout << ans << "\n";
	}
	return 0;
}