#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 998244353
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001
#define ll long long
#define ull unsigned long long

using namespace std;

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ull n, k;
    while (cin >> n >> k)
    {
        if (n == 0 && k == 0)
            return 0;
        bool flag = false, ansflag = false;
        for (ull i = 1; i <= k; i++)
        {
            if (n % i)
            {
                n = ((n / i) + 1) * i;
                flag = true;
            }

            if ((ull)sqrt(n) * (ull)sqrt(n) == n && flag)
            {
                ull p = (ull) sqrt(n);
                if (p <= i)
                {
                    n = ((n / (i + 1)) + 1) * (i + 1);
                    ull delta = n - p * p;
                    cout << delta * k << endl;
                    ansflag = true;
                    break;
                }
            }

            flag = false;
        }

        if (!ansflag)
            cout << n << endl;
    }
    return 0;
}
