#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const int maxn = 2050;
const int mod = 998244353;
void add(int& x, int y) {
	x += y;
	if (x >= mod) x -= mod;
}

void sub(int& x, int y) {
	x -= y;
	if (x < 0) x += mod;
}

int dp[maxn];

int pw(int st) {
	int res = 1;
	forn(i, st) add(res, res);
	return res;
}

bool solve() {
	int n; scanf("%d", &n);
	if (n == 0) return false;
	memset(dp,0,sizeof(dp));
	dp[0] = 1;
	vector<int> a(n);
	forn(i, n) scanf("%d", &a[i]);
	int bad = 0;
	forn(ii, n) {
		int cur = a[ii];
		if (cur > 0 && (cur&(cur-1))==0) {
			for (int i = 2048; i >= cur; --i) add(dp[i], dp[i-cur]);
		} else bad++;
	}
	int ans = pw(n);
	int mult = pw(bad);
	forn(i, 2048) {
		sub(ans, (dp[i] * (ll)mult)%mod);
	}
	printf("%d\n", ans);
	return true;
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	while (solve());
	return 0;
}
