#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e6+11;
const int inf = int(1e9);
const int mod = 998244353;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n, a[maxn];
int good[maxn];
int k[22], t[22];
int dp[22][3000], c[100][100], pr[100][100];
int fact[maxn], inv[maxn];

int binpow(int a, int k) {
	if(k == 0) return 1;
	int ans = binpow(a, k / 2);
	ans = 1ll * ans * ans % mod;
	if(k&1) ans = 1ll * ans * a % mod;
	return ans;
}

int C(int n, int k) {
	int ans = fact[n];
	ans = 1ll * ans * inv[k] % mod;
	ans = 1ll * ans * inv[n-k] % mod;
	return ans;
}

int getsum(int id, int l, int r) {
	if(l > r) return 0;
	int ans = pr[id][r];
	if(l) ans -= pr[id][l-1];
	if(ans < 0) ans += mod;
	return ans;
}

int calc(int ind, int sum) {
	if(ind == 11) return sum >= 2048;
	int &res = dp[ind][sum];
	if(res != -1) return res;
	if(!k[ind]) return res = calc(ind+1, sum);
	res = 0;
	if(sum == 2048) return res = binpow(2, k[ind]) * 1ll * calc(ind+1, sum) % mod;
	res += calc(ind+1, sum); res %= mod;
	for(int i = 1; i <= min(k[ind],2048); i++) {
		if(sum + i * t[ind] >= 2048) {
			int temp = binpow(2, k[ind]);
			for(int j = 0; j < i; j++) {
				temp = (temp - C(k[ind], j) + mod) % mod;
			}
			res = (res + temp * 1ll * calc(ind+1, 2048) % mod) % mod;
			break;
		} else {
			int temp = c[k[ind]][i];
			res = (res + temp * 1ll * calc(ind+1, sum + i * t[ind]) % mod) % mod;
		}
	}
	return res;
}

bool solve() {
	scanf("%d", &n);
	if(!n) return false;
	for(int i = 0; i < n; i++) scanf("%d", a + i);

	memset(k, 0, sizeof k);

	int cnt = 0;
	for(int i = 0; i < n; i++) {
		if(a[i] == 0) cnt++;
		else {
			int p = 1;
			int lvl = 0;
			while(p < a[i]) {
				p *= 2;
				lvl++;
			}
			if(p != a[i]) cnt++;
			else k[lvl]++;
		}
	}

	memset(dp, -1, sizeof dp);

	printf("%d\n", 1ll * calc(0, 0) * binpow(2, cnt) % mod);

	return true;
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	fact[0] = inv[0] = 1;
	for(int i = 1; i < maxn; i++) {
		fact[i] = 1ll* fact[i-1] * i % mod;
		inv[i] = binpow(fact[i], mod-2);
	}

	for(int i = 0; i < 100; i++) c[i][0] = c[i][i] = 1;
	for(int i = 0; i < 100; i++) {
		for(int j = 1; j < i; j++) c[i][j] = (c[i-1][j-1] + c[i-1][j]) % mod;
	}

	for(int i = 0; i < 100; i++) {
		for(int j = 0; j < 100; j++) {
			pr[i][j] = c[i][j];
			if(j) pr[i][j] += pr[i][j-1];
		}
	}

	t[0] = 1;
	for(int i = 1; i < 22; i++) t[i] = 2 * t[i-1];

	while(solve());

	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
