#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int N = (int)10005;
const int inf = (1 << 30) - 1;

struct point {
	double x, y;
	point() : x(), y() {}
	point(double x, double y) : x(x), y(y) {}
	point const operator -(point p) const {
		return point(x - p.x, y - p.y);
	}
};
point p[N], bot;
int T, n, m, h, v[N], a[N], st[N];
char ans[N];

double vect(point v1, point v2) {
	return v1.x * v2.y - v1.y * v2.x;
}
double dist(point p) {
	return p.x * p.x + p.y * p.y;
}

bool cmp(int i, int j) {
	return vect(p[i] - bot, p[j] - bot) < 0 || (vect(p[i] - bot, p[j] - bot) == 0 && dist(bot - p[i]) < dist(bot - p[j]));
}

void build() {
	bot = p[a[0]];
	for (int i = 0; i < n; ++i) {
		if (bot.x > p[a[i]].x || (bot.x == p[a[i]].x && bot.y > p[a[i]].y)) 
			bot = p[a[i]];
	}
	
	sort(a, a + n, cmp); 
	h = 0;
	for (int i = 0; i < n; i++) {
		while (h > 1 && vect(p[st[h-1]] - p[st[h-2]], p[a[i]] - p[st[h-2]]) > 0) h--;
		st[h++] = a[i];
	}
	for (int i = 0; i < h; i++) 
		ans[st[i]] = '1';
}


int main()
{
	

	        
	
	while (true) {
		scanf("%d", &m);
		if (m == 0) break;
		int mx = 0;
		for (int i = 0; i < m; ++i) {
			scanf("%lf %lf %d", &p[i].x, &p[i].y, &v[i]);
			mx = max(mx, v[i]);
		}
		if (mx == 0) {
			for (int i = 0; i < m; i++)
				printf("%c", ans[i]);
			puts("");
			continue;
		}
		n = 0;
		for (int i = 0; i < m; i++) {
			ans[i] = '0';
			if (mx == v[i]) a[n++] = i;
		}
		build();
		for (int i = 0; i < m; i++)
			printf("%c", ans[i]);
		puts("");
	}

	return 0;
}


