#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <stack>

#define v first
#define x second.first.first
#define y second.first.second
#define num second.second
#define all(v) v.begin(), v.end()

using namespace std;

typedef pair<int, pair<pair<int, int>, int>  > point;

typedef pair<int, int> tp;
point mlp;

inline tp gv(const point &a, const point &b)
{
	return make_pair(b.x - a.x, b.y - a.y);
}

inline double ga(tp p) 
{
	return atan2((double)p.second, (double)p.first);
}

const double eps = 1e-9;

bool cmp(const point &a, const point &b)
{
	double aa = ga(gv(mlp, a));
	double ab = ga(gv(mlp, b));

	//cerr << a.num << " " << b.num << " : " << aa << " " << ab << endl;
	if (fabs(aa - ab) < eps) {
		//cerr << a.x << " " << b.x << "xxx <> " << endl;
		return a.x < b.x;
	}
	return aa < ab; 
}

inline bool lr(const tp &a, const tp &b)
{
	//cerr << "FIRST vector " << a.first << ", " << a.second << "; ";
	//cerr << "second vector " << b.first << ", " << b.second << ";\n";
	//cerr << a.first * b.second - a.second * b.first << endl;
	return a.first * b.second - a.second * b.first >= 0;
}

void solve(int n)
{
	vector<point> vc(n);
	int mx = -1;
	int mxc = 1;

	for (int i = 0; i < n; ++i) {
		cin >> vc[i].x >> vc[i].y >> vc[i].v;
		if (mx < vc[i].v) {
			mxc = 1;
			mx = vc[i].v;
		} else {
			if (mx == vc[i].v)
				++mxc;
		}
		vc[i].num = i;
	}

	if (mx == 0) {
		for (int i = 0; i < n; ++i)
			cout << 0;
		return;
	}

	vector<point> cl(mxc);
	int ti = 0;
	for (int i = 0; i < vc.size(); ++i) {
		if (vc[i].v == mx) {
			cl[ti++] = vc[i];
		}
	}
	mlp = cl[0];
	int mlpi = 0;
	for (int i = 0; i < cl.size(); ++i) {
		if (mlp.x > cl[i].x)
			mlp = cl[i], mlpi = i;
	}

	swap(cl.back(), cl[mlpi]);
	sort(cl.begin(), --cl.end(), cmp);
	stack<int> st;
	int nvi = 0;
	st.push(cl.size() - 1);

	for (int i = 1; i < cl.size(); ++i) {
		while (!lr(gv(cl[st.top()], cl[nvi]), gv(cl[nvi], cl[i]))) {
			nvi = st.top();
			st.pop();
		}
		st.push(nvi);
		nvi = i;
	}
	
	vector<int> ans(n, 0);
	
	//cerr << "lol" << endl;
	/*while (!st.empty()) {
		ans[cl[st.top()].num] = 1, st.pop();
	}*/


	bool fuck = false;
	while (!st.empty()) {
		point prev = cl[st.top()];
		st.pop();	
		if (st.empty()) {
			// if (!fuck)
				ans[prev.num] = 1;
			break;
		}

		point top = cl[st.top()];
		if (prev.x == top.x && prev.y == top.y) {
			fuck = true;
		} else {
			// if (!fuck)
				ans[prev.num] = 1;
			fuck = false;
		}
	}
	for (int i = 0; i < ans.size(); ++i)
		cout << ans[i];
}

int main()
{
	ios_base::sync_with_stdio(false);
	int n;
	vector<int> a;
	do {
		cin >> n;
		if (n == 0)
			break;
		solve(n);
		cout << endl;
		malloc(1024 * 1024);
	} while(true);
	
	return 0;
}