#include <iostream>
using namespace std;


long long GCD(long long a, long long b)
{
    while (a > 0 && b > 0) {
        if (a >= b) {
            a %= b;
        } else {
            b %= a;
        }
    }
    return a + b;
}

long long LCM(long long a, long long b)
{
    return a / GCD(a, b) * b;
}

const long long kMaxItr = 1e5;

int main()
{
    ios_base::sync_with_stdio(false);

    while (true) {
        long long x, k;
        cin >> x >> k;

        if (x == 0 && k == 0) {
            break;
        }

        long long diff;
        for (long long i = 1; i <= min(k, kMaxItr); ++i) {
            long long new_x = i * (x / i + (x % i != 0));

            long long diff = new_x - x;

            x = new_x;
        }

        x += diff * (k - min(k, kMaxItr));

        cout << x << endl;
    }
}
