#pragma comment(linker , "/STACK:128000000")

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(true) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

struct Point {
	int x, y, v, id;

	Point() {
	}
	Point(int x, int y) :x(x), y(y){

	}

	Point operator - (const Point& p) const {
		return Point(x - p.x, y - p.y);
	}

	int operator * (const Point& p) const {
		return x * p.y - y * p.x;
	}
	bool operator < (const Point& p) const {
		return mp(x, y) < mp(p.x, p.y);
	}
};

void solve() {
	int n;
	cin >> n;
	if(n == 0)
		exit(0);

	vi ans(n);

	map<pi, int> maxv;
	map<pi, int> maxcnt;
	vector<Point> allPoints;

	int MAXV = 0;
	allPoints.reserve(n);
	for(int i = 0; i < n; ++i) {
		Point p;
		cin >> p.x >> p.y >> p.v;
		p.id = i;
		if(p.v == 0)
			continue;
		MAXV = max(MAXV, p.v);
		if(p.v > maxv[mp(p.x, p.y)]) {
			maxv[mp(p.x, p.y)] = p.v;
			maxcnt[mp(p.x, p.y)] = 1;
		}
		else if(p.v == maxv[mp(p.x, p.y)]) {
			++maxcnt[mp(p.x, p.y)];
		}

		allPoints.push_back(p);
	}

	vector<Point> points;
	for(int i = 0; i < allPoints.size(); ++i) {
		if(MAXV == allPoints[i].v) {
			points.push_back(allPoints[i]);
		}
	}

	sort(all(points));

	vector<Point> top, bottom;

	for(int i = 0; i < points.size(); ++i) {
		while(top.size() >= 2 && (points[i] - top.back()) * (top.back() - top[top.size() - 2]) > 0) {
			top.pop_back();
		}

		top.push_back(points[i]);
#define top bottom
		while(top.size() >= 2 && (points[i] - top.back()) * (top.back() - top[top.size() - 2]) < 0) {
			top.pop_back();
		}

		top.push_back(points[i]);
#undef top
	}

	for(int i = 0; i < top.size(); ++i) {
		bottom.push_back(top[i]);
	}

	for(int i = 0; i < bottom.size(); ++i) {
		Point p = bottom[i];
		if(maxcnt[mp(p.x, p.y)] == 1) {
			ans[p.id] = 1;
		}
	}

	for(int i = 0; i < n; ++i) {
		cout << ans[i];
	}
	cout << "\n";
}