#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second
#define in(n) int (n) = nxt()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int get() {
    char c;
    int res = 0;
    int ok = false;
    while (1) {
        c = getchar();
        if (ok && !isdigit(c)) {
            return res;
        } else {
            if (isdigit(c)) {
                res = res * 10 + c - '0';
                ok = 1;
            } else {
                continue;
            }
        }
    }
    return res;
}

int nxt() {
    return get();
    int res;
    scanf("%d", &res);
    return res;
}

long long mod = 998244353;

long long pw(long long a, long long n) {
    long long res = 1;
    while (n) {
        if (n & 1ll) {
            res = res * a % mod;
        }
        a = a * a % mod;
        n >>= 1;
    }
    return res;
}

long long P = 730033;
long long IP;

const int N = 1 << 12;

long long PW[N];
long long IPW[N];
long long RN;

void fft(long long *a, bool inv = false) {

    for (int i = 1, j = 0; i < N; ++i) {
        int bit = N >> 1;
        while (bit <= j) {
            j -= bit;
            bit >>= 1;
        }
        j += bit;
        if (i < j) {
            swap(a[i], a[j]);
        }
    }

    for (int len = 2, shift = N >> 1; len <= N; len <<= 1, shift >>= 1) {
        int len2 = len >> 1;
        for (int i = 0; i < N; i += len) {
            for (int j = 0; j < len2; ++j) {
                long long u = a[i + j];
                long long v = a[i + j + len2] * (inv ? IPW[shift * j] : PW[shift * j]) % mod;

                a[i + j] = (u + v);
                a[i + j + len2] = u - v;
                if (a[i + j] >= mod) {
                    a[i + j] -= mod;
                }
                if (a[i + j + len2] < 0) {
                    a[i + j + len2] += mod;
                }
            }
        }
    }

    if (inv) {
        for (int i = 0; i < N; ++i) {
            a[i] = (a[i] * RN) % mod;
        }
    }
}

void pre() {
    for (P = 2; ; ++P) {
        if(pw(P, N) == 1 && pw(P, N / 2) != 1) {
            break;
        }
    }
    cerr << P << endl;
    IP = pw(P, mod - 2);
    RN = pw(N, mod - 2);
    PW[0] = IPW[0] = 1;
    for (int i = 1; i < N; ++i) {
        PW[i] = PW[i - 1] * P % mod;
        IPW[i] = IPW[i - 1] * IP % mod;
    }
}

void sq(long long *a) {
    fft(a);
    for (int i = 0; i < N; ++i) {
        a[i] = a[i] * a[i] % mod;
    }
    fft(a, 1);
    for (int i = 2049; i < N; ++i) {
        a[2048] += a[i];
        a[2048] %= mod;
        a[i] = 0;
    }
}

void mul(long long *a, long long *b) {
    long long c1 = a[2048];
    long long c2 = b[2048];
    c1 = c2 * c1 % mod;
    fft(a);
    fft(b);
    for (int i = 0; i < N; ++i) {
        a[i] = a[i] * b[i] % mod;
    }
    fft(a, 1);
    for (int i = 2049; i < N; ++i) {
        a[2048] += a[i];
        a[2048] %= mod;
        a[i] = 0;
    }

    a[0] = (a[0] - c1 + mod) % mod;
    a[2048] = (a[2048] + c1) % mod;
}

void pwTest(long long *res, int k, int n) {
    long long bin = 1;
    long long sumBin = 0;
    memset(res, 0, N * sizeof(long long));
    for (int i = 0; i <= n; ++i) {
        int step = (i * k);
        if (step >= 2048) {
            break;
        }
        res[step] = bin;
        sumBin = (sumBin + bin) % mod;
        long long mu = n - i;
        long long di = pw(i + 1, mod - 2);
        bin = bin * mu % mod * di % mod;
    }
    long long ost = pw(2, n) - sumBin;
    res[2048] = ost;
    if (res[2048] < 0) {
        res[2048] += mod;
    }
}

void pw(long long * a, long long * res, int n) {
    memset(res, 0, N * sizeof(long long));
    res[0] = 1;
    while (n) {
        if (n & 1) {
            mul(res, a);
        }
        sq(a);
        n >>= 1;
    }
}

void test() {
    long long a[N];
    long long b[N];
    memset(a, 0, sizeof(a));
    //memset(b, 0, sizeof(b));
    a[0] = 1, a[1] = 1;
    sq(a);
    sq(a);
    sq(a);
    for (int i = 0; i < 9; ++i) {
        cout << a[i] << " ";
    }
    cout << endl;
    exit(0);
}

void gen() {
    FILE * f = fopen("input.txt", "w");
    int it = 70;
    while (it--) {
        int n = 100000;
        fprintf(f, "%d\n", n);
        for (int i = 0; i < n; ++i) {
            int x = 1 << (rand() % 13);
            fprintf(f, "%d ", x);
        }
        fprintf(f, "\n");
    }
    fprintf(f, "0\n");
    fclose(f);
}

void solve(){
    in(n);
    if (!n) exit(0);
    int cnt[2049];
    memset(cnt, 0, sizeof(cnt));
    for (int i = 0; i < n; ++i) {
        in(x);
        if (!(x & (x - 1))) {
            cnt[x]++;
        } else {
            cnt[0]++;
        }
    }
    long long ans[N];
    memset(ans, 0, sizeof(ans));
    //ans[0] = pw(2, cnt[0]);
    ans[0] = 1;
    for (int i = 1; i <= 2048; i <<= 1) {
        if (cnt[i] > 0) {
            long long res[N];
            //pw(a, res, cnt[i]);
            pwTest(res, i, cnt[i]);
            //cerr << "ASD " << i << endl;
            mul(ans, res);
        }
    }
    ans[2048] = ans[2048] * pw(2, cnt[0]) % mod;
    cout << ans[2048] << "\n";
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    //gen();
    pre();
    //test();
    while (1) {
        solve();
    }

    return 0;
}
