#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 1e5;
const int L = 11;
const int C = 1 << L;

struct Input {
	int n;
	int a[N];
		
	bool read () {
		if (!(scanf("%d", &n) == 1 && n != 0)) {
			return 0;
		}
		
		forn (i, n) {
			scanf("%d", &a[i]);
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	
	void write () {
		printf("%d\n", ans);
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

const int mod = 998244353;

bool isPrime (int x) {
	for (int i = 2; i * i <= x; ++i) {
		if (x % i == 0) {
			return 0;
		}
	}
	return 1;
}

struct Solution: Data {
	int dp[2][C + 1];
	int cnt[L + 1];
	ll inv[C + 1];
	
	int mPow (int x, int y) {
		ll r = 1, c = x;
		while (y > 0) {
			if (y & 1) {
				(r *= c) %= mod;
			}
			(c *= c) %= mod;
			y >>= 1;
		}
		return r;
	}
	
	void solve () {
		memset(cnt, 0, sizeof(cnt));
		for (int i = 1; i <= C; ++i) {
			inv[i] = mPow(i, mod - 2);
		}
		
		int m = 0;
		forn (i, n) {
			if ((a[i] == 0) || (a[i] & (a[i] - 1))) {
				++m;
			}
			else {
				++cnt[__builtin_ctz(a[i])];
			}
		}
		ll e = 1;
		forn (i, m) {
			e *= 2;
			if (e >= mod) {
				e -= mod;
			}
		}
		// debug(m);
		memset(dp[1], 0, sizeof(dp[1]));
		dp[1][0] = 1;
		for (int i = 0; i <= L; ++i) {
			// debug(mp(i, cnt[i]));
			// debug(dp[0], dp[0] + C + 1);
			// debug(dp[1], dp[1] + C + 1);
			
			int k = (1 << (L - i));
			ll e = 0;
			ll c = 1;
			int j;
			// debug(cnt[i]);
			memset(dp[i & 1], 0, sizeof dp[i & 1]);
			for (j = 0; j < k && j <= cnt[i]; ++j) {
				e += c;
				for (int w = 0, q = (j << i); w <= C; ++w, ++q) {
					umn(q, C);
					dp[i & 1][q] += (dp[(i - 1) & 1][w] * c) % mod;
					if (dp[i & 1][q] >= mod) {
						dp[i & 1][q] -= mod;
					}
				}
				(c *= ((cnt[i] - j) * inv[j + 1]) % mod) %= mod;

				if (e >= mod) {
					e -= mod;
				}
			}
			// debug(e);
			if (j >= k) {
        		e = (mPow(2, cnt[i]) - e + mod) % mod;
        		int sm = 0;
        		for (int w = 0; w <= C; ++w) {
        			sm += dp[(i - 1) & 1][w];
        			if (sm >= mod) {
        				sm -= mod;
        			}
        		}
        		dp[i & 1][C] += (e * sm) % mod;
        		if (dp[i & 1][C] >= mod) {
        			dp[i & 1][C] -= mod;
        		}
			}
		}
		// debug(dp[0], dp[0] + C + 1);
		// debug(dp[1], dp[1] + C + 1);
			
		// debug(mp(dp[L & 1][C], e));
		ans = (dp[L & 1][C] * e) % mod;
	}
	
	void clear () {
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("a.in", "r", stdin);
//	freopen("", "w", stdout);
#else
#endif
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}

	return 0;
}
