#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

typedef pa<ll, ll> pt;
#define x first
#define y second

pt operator - (const pt &a, const pt &b) {
	return pt(a.x - b.x, a.y - b.y);
}

ll operator * (const pt &a, const pt &b) {
	return a.x * b.x + a.y * b.y;
}

ll operator ^ (const pt &a, const pt &b) {
	return a.x * b.y - a.y * b.x;
}

const int N = 500;

struct Input {
	int n;
	pt a[N];
	int v[N];
	
	bool read () {
		if (!(cin >> n) || !n) {
			return 0;
		}
		forn (i, n) {
			int x, y;
			scanf("%d%d%d", &x, &y, &v[i]);
			a[i] = pt(x, y);
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	bool ans[N];
	
	void write () {
		forn (i, n) {
			printf("%d", int(ans[i]));
		}
		puts("");
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

struct Solution: Data {
	bool bad[N];
	
	void solve () {
		memset(ans, 0, sizeof ans);
		vi q;
		forn (i, n) {
			q.pb(i);
		}
		sort(all(q), [&] (int i, int j) {return v[i] > v[j];});
		while (v[q[sz(q) - 1]] != v[q[0]]) {
			q.pop_back();
		}
		if (v[q[0]] == 0) {
			return;
		}
		
		sort(all(q), [&] (int i, int j) {return a[i] < a[j];});
		memset(bad, 0, sizeof bad);
		forn (i, sz(q) - 1) {
			if (a[q[i]] == a[q[i + 1]]) {
				bad[q[i]] = bad[q[i + 1]] = 1;
			}
		}
		q.erase(unique(all(q), [&] (int i, int j) {return a[i] == a[j];}), q.end());
		
		sort(q.begin() + 1, q.end(), [&] (int i, int j) {
			pt u = a[i] - a[q[0]];
			pt v = a[j] - a[q[0]];
			ll s = u ^ v;
			if (s) {
				return s > 0;
			}
			return u * u < v * v;
		});
		
		vi c;
		forn (i, sz(q)) {
			while (sz(c) > 1 && ((a[q[i]] - a[c[sz(c) - 2]]) ^ (a[q[i]] - a[c[sz(c) - 1]])) <= 0) {
				c.pop_back();
			}
			c.pb(q[i]);
		}
		debug(q);
		debug(c);
		
		forn (i, sz(c)) {
			forn (j, sz(q)) {
				pt u = a[c[i]] - a[q[j]];
				pt v = a[c[(i + 1) % sz(c)]] - a[q[j]];
				if ((u ^ v) == 0 && (u * v) <= 0) {
					ans[q[j]] = 1;
				}
			}
		}
		
		forn (i, n) {
			if (bad[i]) {
				ans[i] = 0;
			}
		}
	}
	
	void clear () {
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("b.in", "r", stdin);
//	freopen("", "w", stdout);
#else
#endif
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}

