#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 510;

struct Input {
	int n;
	char c[N][N];
	
	bool read () {
		if (scanf ("%d", &n) != 1)
			return 0;
		if (n == 0) {
			return 0;
		}
		string qwe;
		getline(cin, qwe);
		forn(i, n) {
			gets(c[i]);
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	vector <int> ans;
	
	void write () {
		forn(i, ans.size()) {
			cout << ans[i] + 1 << ' ';
		}
		cout << endl;
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

struct Solution: Data {
	int d[N];
	bool use[N];
	
	void solve () {
		memset(use, 0, n * sizeof(bool));
		forn(i, n) {
			d[i] = 0;
		}
		forn(i, n) {
			forn(j, n) {
				if (c[i][j] == '1') {
					d[j]++;
				}
			}
		}
		ans.clear();
		forn(i, n) {
			int minn = -1, mini = -1; 
			forn(j, n) {
				if (!use[j] && d[j] > minn) {
					minn = d[j];
					mini = j;
				}
			}
			use[mini] = 1;
			ans.pb(mini);
			forn(j, n) {
				if (c[mini][j] == '1') {
					d[j]--;
				}
			}
		}
		reverse(all(ans));
	}
	
	void clear () {
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#endif

	return 0;
}
