#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

ll mod = 1000000007;
const int N = 1010;

struct Input {
	int n;
	vi a[N];
	
	bool read () {
		if (!(cin >> n) || !n) {
			return 0;
		}
		forn (i, n) {
			int k;
			scanf("%d", &k);
			forn (j, k) {
				int t;
				scanf("%d", &t);
				--t;
				a[i].pb(t);
			}
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	ll ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

struct Solution: Data {
	ll c[N + 1][N + 1];
	ll f[N + 1];
	
	Solution () {
		forn (i, N + 1) {
			forn (j, N + 1) {
				if (!i || !j) {
					c[i][j] = 1;
				} else {
					c[i][j] = (c[i - 1][j] + c[i][j - 1]) % mod;
				}
			}
		}
		f[0] = 1;
		forn (i, N) {
			f[i + 1] = f[i] * (i + 1) % mod;
		}
	}
	
	int m;
	int k[N], sk[N + 1];
	
	ll d[2][N + 1];

	void solve () {
		{
			int sss = 0;
			forn (i, n) {
				sss += sz(a[i]);
			}
			if (sss != n) {
				ans = 0;
				return;
			}
			vi q;
			forn (i, n) {
				q.insert(q.end(), all(a[i]));
			}
			sort(all(q));
			forn (i, n) {
				if (q[i] != i) {
					ans = 0;
					return;
				}
			} 
		}
		forn (i, n) {
			k[i] = sz(a[i]);
		}
		sort(k, k + n);
		reverse(k, k + n);
		m = 0;
		while (m < n && k[m]) {
			++m;
		}
		sk[0] = 0;
		forn (i, m) {
			sk[i + 1] = sk[i] + k[i];
		}
		forn (i, 2) {
			memset(d[i], 0, (m + 1) * sizeof(ll));
		}
		d[0][0] = 1;
		forn (i, m) {
			int i0 = i & 1;
			int i1 = i0 ^ 1;
			memset(d[i1], 0, (m + 1) * sizeof(ll));
			forn (j, i + 1) {
				d[i0][j] %= mod;
				int bnd = min(j + 1, k[i]) + 1;
				forn (t, bnd) {
					ll x = c[j - t][t] * c[k[i] - t][t] % mod * f[t] % mod * d[i0][j] % mod;
					d[i1][j - t + 1] += x;
					d[i1][j - t] += x * (sk[i] - (i - j));
				}
			}
		}
		ans = d[m & 1][0] % mod;
	}
	
	void clear () {
		forn (i, n) {
			a[i] = vi();
		}
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("k.in", "r", stdin);
//	freopen("", "w", stdout);
#else
#endif
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
	return 0;
}
