#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const long long mdl = 998244353;
const long long sqmdl = mdl * mdl;
const int size = 1000 * 100 + 100;
const int ssize = 15;
const int magic = 3000;

long long ans[ssize][magic];
int n;
int rnum[size];
long long cnk[magic];
int cnt[ssize];
int pw2[size];

long long fpw(long long a, long long b, long long m) {
	if (b == 0)
		return 1;
	long long d = fpw(a, b / 2, m);
	d = (d * d) % m;
	if (b & 1)
		d = (d * a) % m;

	return d;
}

int back(int val) {
	return fpw(val, mdl - 2, mdl);
}

int main() {
	/*
	freopen("input.txt", "w", stdout);
	int tc = 10;
	for (int it = 0; it < tc; it++) {
		int n = 100 * 1000;
		printf("%d\n", n);
		for (int i = 0; i < n; i++)
			printf("%d ", 1 << (rand() % 10));
		printf("\n");
	}

	return 0;
	*/
	for (int i = 0; i < ssize; i++)
		rnum[1 << i] = i + 1;
	pw2[0] = 1;
	for (int i = 1; i < size; i++) {
 		pw2[i] = (pw2[i - 1] * 2);
		if (pw2[i] >= mdl)
			pw2[i] -= mdl;
	}

//	assert(freopen("input.txt", "r", stdin));
//	assert(freopen("output.txt", "w", stdout));

	while (true) {
		scanf("%d", &n);
		if (n == 0)
			break;
		int nonpow = 0;
		int good = 0;
		for (int i = 0; i < ssize; i++)
			cnt[i] = 0;
		for (int i = 0; i < n; i++) {
			int d;
			scanf("%d", &d);
			if (rnum[d] == 0) {
				nonpow++;
			} else {
				cnt[rnum[d]]++;
				good++;
			}
		}

		for (int i = 0; i < ssize; i++)
			for (int j = 0; j < 2048; j++)
				ans[i][j] = 0;
		ans[0][0] = 1;
		for (int i = 0; i < ssize - 1; i++) {
			cnk[0] = 1;
			int p = (1 << i);
			
			for (int j = 1; j <= min(cnt[i + 1], 2048 / p); j++) {
				cnk[j] = (((cnk[j - 1] * 1ll * (cnt[i + 1] - j + 1)) % mdl) * back(j)) % mdl;
			}
			for (int j = 0; j < 2048; j++) {
				if (ans[i][j] != 0) {
					ans[i][j] %= mdl;
					for (int k = 0, jump = j; k <= cnt[i + 1] && jump < 2048; k++, jump += p) {
						ans[i + 1][jump] += ans[i][j] * cnk[k];
						if (ans[i + 1][jump] >= sqmdl)
							ans[i + 1][jump] -= sqmdl;
					}
				}
			}
		}

		long long curans = pw2[good];
		for (int j = 0; j < 2048; j++) {
			curans = (curans - ans[ssize - 1][j] + mdl);
			if (curans >= mdl)
				curans -= mdl;
		}

		printf("%lld\n", curans * pw2[nonpow] % mdl);
	}

//	cout << (clock() + 0.0) / CLOCKS_PER_SEC << endl;

	return 0;
}