#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const ldb pi = acos(-1.0);
const ldb eps = 1e-12;
const int N = (int) 555;
int n, x[N], y[N], v[N];

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	while ((scanf("%d", &n) == 1) && (n > 0)) {
		int mx = 0;
		for (int i = 0; i < n; ++i) {
			scanf("%d%d%d", &x[i], &y[i], &v[i]);
			mx = max(mx, v[i]);
		}
		for (int i = 0; i < n; ++i) {
			if (v[i] != mx) {
				printf("0");
				continue;
			}
			vector<ldb> a;
			bool bad = false;
			for (int j = 0; j < n; ++j) {
				if ((v[j] != mx) || (i == j)) continue;
				if ((x[i] == x[j]) && (y[i] == y[j])) {
					bad = true;
					break;
				}
				a.pb(atan2l((ldb) y[i] - y[j], (ldb) x[i] - x[j]));
			}
			if (bad) {
				printf("0");
				continue;
			}
			sort(a.begin(), a.end());
			if (a.empty()) {
				printf("1");
				continue;
			}
			a.pb(a[0] + 2 * pi);
			bool done = false;
			for (int i = 0; i + 1 < sz(a); ++i)
				if (a[i + 1] - a[i] > pi - eps) {
					done = true;
					break;
				}
			printf("%c", done ? '1' : '0');
		}
		printf("\n");
	}
	return 0;
}