#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int size = 1000;

char field[size][size];
int n;
int deg[size];
bool used[size];

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));

	while (true) {
		scanf("%d", &n);
		if (n == 0)
			break;
		for (int i = 0; i < n; i++)
			scanf("%s", field[i]);
		for (int i = 0; i < n; i++) {
			deg[i] = 0;
			used[i] = false;
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++)
				deg[j] += field[i][j] == '1';
		}

		for (int i = 0; i < n; i++) {
			int b = -1;
			for (int j = 0; j < n; j++)
				if (!used[j] && (b == -1 || deg[j] < deg[b])) {
					b = j;
				}
			used[b] = true;

			printf("%d%c", b + 1, " \n"[i == n - 1]);
			for (int j = 0; j < n; j++)
				deg[j] -= field[b][j] == '1';
		}
	}

	return 0;
}