#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int M = (int) 1e9 + 7;
const int N = 2000;
int coef[N], cnt[N], k[N], n, x, deg, cnt0, tmp, ans;

int mult(int a, int b) {
	return (a * (int64) b) % M;
}

int sum(int a, int b) {
	return (a + b) % M;
}



int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	while ((scanf("%d", &n) == 1) && (n > 0)) {
		for (int i = 0; i < n; ++i)
			cnt[i] = 0;
		for (int i = 0; i < n; ++i) {
			scanf("%d", &k[i]);
			for (int j = 0; j < k[i]; ++j)
				scanf("%d", &x), cnt[x - 1]++;
		}
		bool trash = false;
		for (int i = 0; i < n; ++i)
			if (cnt[i] != 1) {
				trash = true;
				break;
			}
		if (trash) {
			printf("0\n");
			continue;
		}
		deg = 1, coef[0] = 1, cnt0 = 0, tmp = 1, ans = 0;
		for (int i = 0; i < n; ++i)
			if (k[i] != 0) {
				coef[deg] = 0;
				for (int j = deg; j >= 1; --j)
					coef[j] = sum(coef[j - 1], mult(coef[j], M - k[i]));
				coef[0] = mult(coef[0], M - k[i]);
				deg++;
			} else
				cnt0++;
		for (int i = 0; i < deg; ++i) {
			ans = sum(ans, mult(coef[i], tmp));
			tmp = mult(tmp, cnt0 + i + 1);
		}
		printf("%d\n", ans);
	}
	return 0;
}