#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

ll x, k; 
bool ok = 0; 

ll sol1(ll x, ll k) {
	for (ll i = 1; i <= k; i++) {
			x = (x + i - 1) / i * i; 
			ll t = x / i; 
			if (i + 1 > t) {
				return t * k; 
			}
		}
	return x; 
}

ll sol2(ll x, ll k) {
	for (ll i = 1; i <= k; i++) {
			x = (x + i - 1) / i * i; 
		}
	return x; 
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	//for (int i = 0; i < 100000; i++) {
	//	ll x = rand(); 
	//	ll k = rand(); 

	//	if (sol1(x, k) != sol2(x, k)) {
	//		cout << x << " " << k << "\n";
	//	}
	//}
	//return 0; 
	
	while (cin >> x >> k) {
		if (!x) break; 
		ok = 0; 
		for (ll i = 1; i <= k; i++) {
			x = (x + i - 1) / i * i; 
			ll t = x / i; 
			if (i + 1 > t) {
				cout << t * k << "\n"; 
				ok = 1;
				break; 
			}
		}
		if (!ok) cout << x << "\n"; 
	}

	return 0;
}