#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int MOD = 998244353;

int cnt[3000], d[3000], nd[3000];
int pw[100100], f[100100], rf[100100];

inline int calc(int a, int b) {
	int res = 1;
	while (b > 0) {
		if (b % 2 != 0) {
			res = (1LL * res * a) % MOD;
		}
		a = (1LL * a * a) % MOD;
		b /= 2;
	}
	return res;
}

inline void init() {
	pw[0] = f[0] = 1;
	for (int i = 1; i < 100100; ++i) {
		pw[i] = (2LL * pw[i - 1]) % MOD;
		f[i] = (1LL * f[i - 1] * i) % MOD;
	}
	for (int i = 0; i < 100100; ++i) {
		rf[i] = calc(f[i], MOD - 2);
	}
}

inline int cnk(int n, int k) {
	if (k == 0 || k == n) {
		return 1;
	}
	if (k > n || k < 0) {
		return 0;
	}
	int res = (1LL * f[n] * rf[k]) % MOD;
	res = (1LL * res * rf[n - k]) % MOD;
	return res;
}

inline bool solve() {
	int n;
	scanf("%d", &n);
	if (n == 0) {
		return false;
	}
	for (int i = 1; i <= 2048; ++i) {
		cnt[i] = 0;
	}
	int bad = 0;
	for (int i = 0; i < n; ++i) {
		int cur;
		scanf("%d", &cur);
		if (cur > 0 && (cur & (cur - 1)) == 0) {
			++cnt[cur];
		} else {
			++bad;
		}
	}
	for (int i = 0; i <= 2048; ++i) {
		d[i] = 0;
	}
	d[0] = 1;
	for (int i = 1; i <= 2048; ++i) {
		if (cnt[i] == 0) {
			continue;
		}
		for (int j = 0; j <= 2048; ++j) {
			nd[j] = 0;
		}
		for (int j = 0; j <= 2048; ++j) {
			int ptr = 0, sum = pw[cnt[i]];
			while (ptr <= cnt[i] && j + i * ptr < 2048) {
				int c = cnk(cnt[i], ptr);
				nd[j + i * ptr] = (nd[j + i * ptr] + 1LL * c * d[j]) % MOD;
				sum -= c;
				if (sum < 0) {
					sum += MOD;
				}
				++ptr;
			}
			nd[2048] = (nd[2048] + 1LL * sum * d[j]) % MOD;
		}
		for (int j = 0; j <= 2048; ++j) {
			d[j] = nd[j];
		}
	}
	int ans = (1LL * d[2048] * pw[bad]) % MOD;
	printf("%d\n", ans);
	return true;
}

int main() {
#ifdef LOCAL42
#define TASK "A"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	init();
	while (solve());
	return 0;
}
