#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

const LL MOD = 998244353;
LL mpow(LL x, LL p) {
  LL b = 1;
  while (p) {
    if (p & 1) b = b * x % MOD;
    x = x * x % MOD;
    p /= 2;
  }
  return b;
}
LL minv(LL x) {
  return mpow(x, MOD - 2);
}
LL xinv[2049];

LL cnk[2049];
void getcnk(LL n) {
  cnk[0] = 1;
  FOR(i, 1, 2049) {
    if (i > n) cnk[i] = 0;
    else cnk[i] = (cnk[i - 1] * (n - i + 1) % MOD) * xinv[i] % MOD;
  }
}

int n;
int nums[131072];
int cnt[2049];
LL dp[2049];
LL dp2[2049];

void test() {
  memset(cnt, 0, sizeof cnt);
  FOR(i, 0, n) {
    scanf("%d", &nums[i]);
    if (nums[i] == 0 || nums[i] & (nums[i] - 1)) {
      cnt[0]++;
    } else {
      cnt[nums[i]]++;
    }
  }
  memset(dp, 0, sizeof dp);
  dp[0] = 1;
  for (int x = 1; x <= 2048; x *= 2) {
    if (cnt[x] == 0) continue;
    getcnk(cnt[x]);
    memset(dp2, 0, sizeof dp2);
    FOR(a, 0, 2048) {
      for (int b = 0; b <= cnt[x] && a + b * x < 2048; b++) {
        dp2[a + b * x] = (dp2[a + b * x] + dp[a] * cnk[b]) % MOD;
      }
    }
    memcpy(dp, dp2, sizeof dp);
  }
  LL ans = mpow(2, n - cnt[0]);
  FOR(i, 0, 2048) ans = (ans - dp[i] + MOD) % MOD;
  printf("%d\n", int(ans * mpow(2, cnt[0]) % MOD));
}

int main() {
  FOR(i, 1, 2049) xinv[i] = minv(i);
  while (true) {
    scanf("%d", &n);
    if (!n) break;
    test();
  }
  return 0;
}
