#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 200*1000 + 10;
const dbl eps = 1e-7;
const int mod = 1e9 + 9;


int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
#define TES
	#ifdef TEST
	int n = 10;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cout << i*j / n << i*j % n << ' ';
		}
		puts("");
	}
	return 0;
	

#else
	int p;
	scanf("%d", &p);
	while (p != 0) {
		vector <pair <pair <int, int>, int> > v (p);
		for (int i = 0; i < p; i++) {
			v[i].Y = i;
		}
		for (int i = 0; i < p; i++) {
			set <int> s1, s2;
			for (int j = 0; j < p; j++) {
				int x, y;
				scanf("%d%d", &x, &y);
				s1.insert(x);
				s2.insert(y);
			}
			v[i].X = mp(sz(s1), sz(s2));
		}
		sort(v.begin(), v.end());
		for (int i = 0; i < p; i++) {
			printf("%d ", v[i].Y);
		}
		puts("");
		scanf("%d", &p);
	}
	return 0;
#endif
}