#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <cstring>
using namespace std;

template <class T> int size(const T&x) { return x.size(); }

typedef long long ll;
typedef vector<int> vi;

ll mod = 998244353;
vi arr;

int main() {
    // ll cnt[2049];

    ll cnt[2][2049];
    ll po[2049];
    ll p2[12];
    memset(po, -1, sizeof(po));
    for (int i = 1, j = 0; i <= 2048; i *= 2, j++) {
        po[i] = j;
        p2[j] = i;
    }

    int n;
    while (scanf("%d\n", &n) != EOF && n != 0) {
        memset(cnt, 0, sizeof(cnt));

        vector<int> arr(n);
        for (int i = 0; i < n; i++) {
            ll x;
            cin >> arr[i];
            if ((arr[i] & (arr[i]-1)) != 0) {
                arr[i] = 0;
            }
            //arr[i] = po[arr[i]];
        }

        cnt[1][0] = 1;
        for (int i = 0; i < n; i++) {
            int x = arr[i];
            for (int j = 0; j <= 2048; j++) {
                cnt[i&1][j] = cnt[~i&1][j];
            }

            for (int j = 0; j <= 2048; j++) {
                cnt[i&1][min(2048,j+x)] += cnt[~i&1][j];
            }
        }

        cout << cnt[~n&1][2048] << endl;

        /*
        memset(cnt, 0, sizeof cnt);
        sort(in.begin(), in.end());
        int curpow = 0;
        for(int i = 0; i < size(in); ++i){
            cout << in[i] << endl;
            if(in[i] > (1 << curpow)){
                cout << cnt[curpow] << endl;
                while(in[i] > (1 << curpow)) curpow++;
                curpow++;
                // cnt[i+1] += choose(cnt[i], 2);
                cnt[curpow+1] += (cnt[curpow]*(cnt[curpow]-1) / 2) % mod;
                cnt[curpow+1] %= mod;
            }
            cnt[curpow+1] += cnt[curpow];
            cnt[curpow+1] %= mod;
            cnt[curpow]++;
            cnt[curpow] %= mod;
        }
        for(int i = curpow; i < 11; ++i){
            cnt[i+1] += (cnt[i]*(cnt[i]-1) / 2) % mod;
            cnt[i+1] %= mod;
        }

        //printf("%d\n", cnt[13]);
        cout << cnt[11] << endl;
        cout << endl;
        in.clear();
        */
    }

    return 0;
}
