#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

int cnt[2049], n;
li ways[2][2049];

bool read() {
	if (scanf("%d", &n) != 1)
		return false;

	if (n == 0)
		return false;

	memset(ways, 0, sizeof(ways));

	forn(i, 2049)
		cnt[i] = 0;
	forn(i, n) {
		int a;
		scanf("%d", &a);
		if (a & (a - 1))
			a = 3;
		cnt[a]++;
	}
	return true;
}

const int MOD = 998244353;

int binpow(int a, int b, int m) {
	li cur = a, res = 1;
	for (int i = 0; (1 << i) <= b; ++i) {
		if (b & (1 << i))
			res = (res * cur) % m;
		cur = (cur * cur) % m;
	}

	return res;
}

void solve() {
	int t = 0;
	ways[t][0] = 1;

	forn(i, 2049) {
		if (!cnt[i])
			continue;

		forn(j, 2049)
			ways[!t][j] = 0;

		if (i & (i - 1)) {
			forn(j, 2049)
				ways[!t][j] = (ways[t][j] * binpow(2, cnt[j], MOD)) % MOD;
		} else {
			li C = 1;
			li avg = binpow(2, cnt[i], MOD);
			forn(k, min(cnt[i], 2048) + 1) {
				if (k) {
					C = (C * (cnt[i] - k + 1)) % MOD;
					C = (C * binpow(k, MOD - 2, MOD)) % MOD;
				}

				avg = (avg - C + MOD) % MOD;

				forn(j, 2049) {
					li& w = ways[!t][min(2048, j + k * i)];
					w = (w + ways[t][j] * C) % MOD;
				}
			}

			if (cnt[i] > 2048)
				forn(j, 2049) {
					li& w = ways[!t][2048];
					w = (w + ways[t][j] * avg) % MOD;
				}
		}

		t = !t;
	}

	printf("%d\n", int(ways[t][2048]));
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while(read())
		solve();

	return 0;
}