#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

int n;
li x, k;

bool read() {
	/*x = (li(rand()) << 32) + (li(rand()) << 16) + (li(rand()) << 0) + 5;
	k = rand() % 100000 + 1;
	return true;
	*/if (!(cin >> x >> k))
		return false;

	if (x == 0)
		return false;

	return true;
}

li naive(li x) {
	li nx;
	forn(i, k) {
		li m = x % (i + 1);
		nx = x;
		if (m)
			nx += (i + 1) - m;

		x = nx;
	}

	return x;
}

void solve() {
	li lx = x;
	li d;
	for (int i = 1; i <= k; ++i)
	{
		int add = (i - x % i);
		if (add == i)
			add = 0;
		x += add;
		if (i >= 120000)
		{
			d = x - lx;
			x += d * (k - i);
			break;
		}
		lx = x;
	}
	cout << x << endl;
	return;
	li cx = x;
	li prev = -1;

	forn(i, k) {
		li m = x % (i + 1);
		li nx = x;
		if (m)
			nx += (i + 1) - m;

		li cur = nx - x;
		if (i > 10000 && cur == prev && prev > 0) {
			nx += (k - (i + 1)) * cur;
			assert(nx == naive(cx));
			cout << nx << endl;
			return;
		}

		prev = cur;
		x = nx;
		
	}
	cout << x << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while(read())
		solve();

	return 0;
}