#include <iostream>
#include <complex>
#include <vector>
#include <algorithm>
#include <set>
#include <iomanip>

using namespace std;

int p;
int T[500];
int dist[500];
int perm[500];

int main() {
	cin.sync_with_stdio(false);
	
	while(true) {
		cin >> p;
		if(p == 0) break;
		
		for(int i = 0; i < p; ++i) {
			int x = p;
			int y = -1;
			for(int j = 0; j < p; ++j) {
				int a, b;
				cin >> a >> b;
				x = min(x, min(a, b));
				y = max(y, max(a, b));
				T[j] = a;
			}
			if(x == y) {
				dist[i] = 0;
			} else {
				sort(T, T + p);
				dist[i] = unique(T, T + p) - T;
			}
		}
		
		for(int i = 0; i < p; ++i) {
			perm[dist[i]] = i;
		}
		for(int i = 0; i < p; ++i) {
			if(i != 0) cout << ' ';
			cout << perm[i];
		}
		cout << '\n';
	}

	return 0;
}
