#include <iostream>
#include <complex>
#include <vector>
#include <algorithm>

using namespace std;
typedef long long int Z;
typedef complex<Z> V;

int main() {
	cin.sync_with_stdio(false);
	
	while(true) {
		Z x, k;
		cin >> x >> k;
		if(x == 0) break;
		
		Z i = 1;
		Z sd = 0;
		Z sl = 0;
		while(i <= k) {
			Z oldx = x;
			x = (x + i - 1) / i * i;
			Z d = x - oldx;
			if(d == sd) {
				++sl;
			} else {
				sd = d;
				sl = 1;
			}
			++i;
			if(sl == 100) {
				break;
			}
		}
		x += sd * (k + 1 - i);
		cout << x << "\n";
	}

	return 0;
}
