#include <stdio.h>
#include <memory.h>
#include <iostream>

using namespace std;

const int BASE = 998244353;
const int K = 2048;
const int N = 500500;

int cnt[15], n, lt[N], rev[N], f[15][K + 10], a[N];

int pw(int x, int y) {
	int res = 1;
	while (y) {
		if (y % 2) {
			res = (res * 1LL * x) % BASE;
		}
		x = (x * 1LL * x) % BASE;
		y /= 2;
	}
	return res;
}

int main() {
	freopen("input.txt", "r", stdin);
	for (int i = 0; i < N; i++) rev[i] = pw(i, BASE - 2);
	lt[0] = 0;
	lt[1] = 0;
	for (int i = 2; i < N; i++) lt[i] = lt[i >> 1] + 1;
	scanf("%d", &n);
	while (n != 0) {
		for (int i = 0; i < 12; i++) cnt[i] = 0;
		int sum = n;
		for (int i = 0; i < n; i++) {
			scanf("%d", &a[i]);
			if (a[i] & (a[i] - 1)) continue;
			if (a[i] == 0) continue;
			cnt[lt[a[i]]]++;
			sum--;
		}
		memset(f, 0, sizeof(f));
		f[0][0] = 1;
		for (int i = 0; i < 12; i++) {
			for (int j = 0; j <= K; j++) {
				if (f[i][j] == 0) continue;
				int curC = 1;
				for (int e = 0; e <= cnt[i]; e++) {
					int nj = j + (1 << i) * e;
					if (nj >= K) nj = K;
					int cur = (f[i][j] * 1LL * curC) % BASE;
					f[i + 1][nj] += cur;
					if (f[i + 1][nj] >= BASE) f[i + 1][nj] -= BASE;
					curC = (curC * 1LL * (cnt[i] - e)) % BASE;
					curC = (curC * 1LL * rev[e + 1]) % BASE;
				}
			}
		}
		int res = f[12][K];
		for (int i = 0; i < sum; i++) {
			res += res;
			if (res >= BASE) res -= BASE;
		}
		printf("%d\n", res);
		scanf("%d", &n);
	}
}