#include <stdio.h>

using namespace std;

const int N = 1111;


int x[N], y[N], v[N];
int n, mn;

bool check(double xx, double yy, int kv, int nom) {
	long double dd = (xx - x[nom]) * (xx - x[nom]) + (yy - y[nom]) * (yy - y[nom]);
	for (int i = 0; i < n; i++) {
		if (i == nom) continue;
		if (v[i] != kv) continue;
		long double d2 = (xx - x[i]) * (xx - x[i]) + (yy - y[i]) * (yy - y[i]);
		if (d2 < dd) return false;
	}
	return true;
}

int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d", &n);
	while (n > 0) {
		mn = -1;
		for (int i = 0; i < n; i++) {
			scanf("%d%d%d", &x[i], &y[i], &v[i]);
			if (v[i] > mn) mn = v[i];
		}
		for (int i = 0; i < n; i++) {
			if (v[i] != mn) {
				putchar('0');
				continue;
			}
			bool found = false;
			bool flag = false;
			for (int j = 0; j < n; j++) {
				if (j == i) continue;
				if (v[j] != mn) continue;
				flag = true;
				int vx = y[j] - y[i];
				int vy = x[i] - x[j];
				if (check(x[i] + vx * 1e5, y[i] + vy * 1e5, mn, i)) {
					found = true;
					break;
				}
				if (check(x[i] - vx * 1e5, y[i] - vy * 1e5, mn, i)) {
					found = true;
					break;
				}
			}
			putchar(found || !flag ? '1' : '0');
		}
		puts("");
		scanf("%d", &n);
	}
}
