#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

const int N = 1111;

int x[N], y[N], v[N], used[N], found;
int n, mn;
vector<pair<pair<int, int>, pair<int, int>>> vv;

long long way(long long x0, long long y0, long long x1, long long y1) {
	long long w = x0 * y1 - x1 * y0;
	if (w < 0) return -1;else
	if (w > 0) return +1;else
	return 0;
}

void dfs(int x, int px) {
	if (found) return;
	used[x] = 1;
	for (int i = 0; i < vv.size(); i++) {
		if ((i == x) || (i == px)) continue;
		if (way(vv[x].second.first, vv[x].second.second, vv[i].second.first, vv[i].second.second) < 0) {
			if (used[i] == 1) {
				found = true;
				return;
			}
			if (used[i] == 0) dfs(i, x);
		}
	}
	used[x] = 2;
}

int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d", &n);
	while (n > 0) {
		mn = -1;
		for (int i = 0; i < n; i++) {
			scanf("%d%d%d", &x[i], &y[i], &v[i]);
			x[i] += x[i];
			y[i] += y[i];
			if (v[i] > mn) mn = v[i];
		}
		for (int i = 0; i < n; i++) {
			if (v[i] != mn) {
				putchar('0');
				continue;
			}
			bool flag = false;
			for (int j = 0; j < n; j++) {
				if (j == i) continue;
				if (v[j] != mn) continue;
				if ((x[j] == x[i]) && (y[j] == y[i])) {
					flag = true;
					break;
				}
			}
			if (flag) {
				putchar('0');
				continue;
			}
			vv.clear();
			for (int j = 0; j < n; j++) {
				if ((j == i) || (v[j] != mn)) continue;
//				cerr << j << endl;
				long long x0 = (x[i] + x[j]) / 2;
				long long y0 = (y[i] + y[j]) / 2;
				long long vx = y[j] - y[i];
				long long vy = x[i] - x[j];
				if (way(vx, vy, x[i] - x0, y[i] - y0) > 0) {
					vx *= -1;
					vy *= -1;
				}
				vv.push_back(make_pair(make_pair(x0, y0), make_pair(vx, vy)));
			}
			for (int j = 0; j < vv.size(); j++) used[j] = 0;
			found = false;
			for (int j = 0; j < vv.size(); j++) {
				if (used[j]) continue;
				dfs(j, -1);
			}
			if (found) putchar('0');
			else putchar('1');
		}
		puts("");
		scanf("%d", &n);
	}
}
