#include <iostream>
#include <ctime>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

const int N = 1111;

int x[N], y[N], v[N], used[N], found, tx[N], ty[N];
int cv;
char ans[N];
int n, mn;
pair<int, int> vv[N];

void dfs(int x) {
	used[x] = 1;
	for (int i = 0; i < cv; i++) {
		if (used[i] == 2) continue;
		int ww = vv[x].first * vv[i].second - vv[x].second * vv[i].first;
		if (ww < 0) {
			if (used[i] == 1) {
				found = true;
				return;
			}
			dfs(i);
		}
	}
	used[x] = 2;
}

int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d", &n);
	while (n > 0) {
		mn = -1;
		for (int i = 0; i < n; i++) {
			scanf("%d%d%d", &x[i], &y[i], &v[i]);
			tx[i] = x[i];
			ty[i] = y[i];
			x[i] += x[i];
			y[i] += y[i];
			if (v[i] > mn) mn = v[i];
		}
		for (int i = 0; i < n; i++) ans[i] = '?';
		for (int i = 0; i < n; i++) {
			if (ans[i] != '?') continue;
			if (v[i] != mn) {
				ans[i] = '0';
				continue;
			}
			bool flag = false;
			for (int j = i + 1; j < n; j++) {
				if ((x[j] == x[i]) && (y[j] == y[i])) {
					ans[j] = '0';
					flag = true;
				}
			}
			if (flag) {
				ans[i] = '0';
				continue;
			}
			cv = 0;
			for (int j = 0; j < n; j++) {
				if ((j == i) || (v[j] != mn)) continue;
//				cerr << j << endl;
				int x0 = (tx[i] + tx[j]);
				int y0 = (ty[i] + ty[j]);
				int vx = y[j] - y[i];
				int vy = x[i] - x[j];
				int ww = (vx * (y[i] - y0) - vy * (x[i] - x0));
				if (ww > 0) {
					vx *= -1;
					vy *= -1;
				}
				vv[cv++] = make_pair(vx, vy);
			}
			for (int j = 0; j < cv; j++) used[j] = 0;
			random_shuffle(vv, vv + cv);
			cv = min(cv, 300);
			found = false;
			for (int j = 0; j < cv; j++) {
				if (!used[j]) dfs(j);
				if (found) break;
			}
			if (found) ans[i] = '0';
			else ans[i] = '1';
		}
		puts(ans);
		scanf("%d", &n);
	}
	cerr << clock() << endl;
}
