#include <stdio.h>
#include <ctime>
#include <algorithm>
#include <iostream>
#include <string.h>
#include <vector>

using namespace std;

const int maxn = 10;
const unsigned char inf = 250;


unsigned char dp[maxn + 3][maxn][1 << maxn][1 << maxn];

int n, m;
char a[maxn][maxn + 1];

int main() {
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	
	while (1) {
		cin >> n >> m;
		if (!n && !m) break;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				cin >> a[i][j];
			}
			a[i][m] = '0';
		}

		for (int j = 0; j <= m + 2; j++) {
			for (int i = 0; i < n; i++) {
				for (int mask1 = 0; mask1 < 1 << n; mask1++) {
					for (int mask2 = 0; mask2 < 1 << n; mask2++) {
						dp[j][i][mask1][mask2] = inf;
					}
				}
			}
		}
		//memset(dp, 255, sizeof(dp));
		int mask0 = 0;
		for (int i = 0; i < n; i++) mask0 |= (a[i][0] - '0') << i;
		for (int mask1 = 0; mask1 < 1 << n; mask1++) {
			dp[1][0][mask1][mask0] = 0;
		}

		for (int j = 1; j <= m; j++) {
			for (int i = 0; i < n; i++) {
				for (int mask1 = 0; mask1 < 1 << n; mask1++) {
					for (int mask2 = 0; mask2 < 1 << n; mask2++) {
						if (dp[j][i][mask1][mask2] == inf) continue;
						int toDelete = mask1 & (1 << i);
						
						int nj = j;
						int ni = i + 1;
						if (ni == n) {
							ni = 0;
							nj++;
						}
						int nmask1 = mask1;
						nmask1 &= (1 << n) - 1 - (1 << i);
						nmask1 |= mask2 & (1 << i);
							
						int nmask2 = mask2;
						nmask2 &= (1 << n) - 1 - (1 << i);
						nmask2 |= (a[i][j] - '0') << i;
					
						int cur = dp[j][i][mask1][mask2];
		if (toDelete != 0) {
			cur++;
			//int nnmask1 = nmask1;
			//int nnmask2 = nmask2;
			if (i > 0) {
				nmask1 ^= (1 << (i - 1));
			}
			if (i + 1 < n) {
				nmask2 ^= (1 << (i + 1));
			}       	
			nmask2 ^= 1 << i;
			if (cur < dp[nj][ni][nmask1][nmask2]) dp[nj][ni][nmask1][nmask2] = cur;
			//nnmask1 = nmask1;
			//nnmask2 = nmask2;
			nmask1 ^= 1 << i;
			if (cur < dp[nj][ni][nmask1][nmask2]) dp[nj][ni][nmask1][nmask2] = cur;
		} else {	
			if (cur < dp[nj][ni][nmask1][nmask2]) dp[nj][ni][nmask1][nmask2] = cur;
			cur += 2;
			//int nnmask1 = nmask1;
			//int nnmask2 = nmask2;
			nmask1 ^= 1 << i;
				if (cur < dp[nj][ni][nmask1][nmask2]) dp[nj][ni][nmask1][nmask2] = cur;
						}
					}
				}
			}
		}
		unsigned char mx = inf;
		for (int mask2 = 0; mask2 < 1 << n; mask2++) {
			mx = min(mx, dp[m + 1][0][0][mask2]);
		}
		cout << (int)mx << endl;
	}
	cerr << clock() << endl;
	return 0;
}
