#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;



ll gdc(ll a,ll b){
	while(b){
		a%=b;
		swap(a,b);
	}
	return a;
}
ll stupid(ll x,ll k){
	for(int i = 1;i <= k;i++){
		if(x%i!=0){
			ll ch = x/i;
			ch++;
			ch*=i;
			x = ch;
//			printf("%d %d\n",i,ch);
		}
	}
	return x;
}
ll smart(ll x,ll k){
	ll last = 0;
	ll cnt = k;
	ll start = x;
	for(int i = 1;(i*i <= 4*start) && cnt;i++){
		if(x%i!=0){
			ll ch = x/i;
			ch++;
			ch*=i;
			last = ch-x;
			x = ch;
		}
		cnt--;
	}
	x+=(cnt*last);

	return x;
}
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	
	//ll x,y;
	//cin >> x >> y;
	//ll c1 = smart(x,y);
	//ll c2 = stupid(x,y);

	//cout << c1 << " ";
	//cout << c2 << endl;
	while(true){
		ll x,y;
		cin >> x >> y;
		if(x==0 && y==0)
			break;
		cout << smart(x,y) << endl;
	}

	return 0;
}
