#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)6e5;
const int inf = (1 << 30) - 1;

LL f[maxn], T, pre[maxn], o, n, buf[maxn], g[maxn], was[maxn], l, q, v, d, p;
LL sum, res;
vector <int> r;

void upd(int v, LL x)
{
	if (v > l)
		return;
	for (int i = v; i <= l; i |= (i + 1))
		f[i] += x;
}

LL get(int v)
{
	res = 0;
	for (int i = v; i > 0; i = (i & (i + 1)) - 1)
		res += f[i];
   	return res;
}

void clear()
{
    for (int i = 1; i <= l; i++)
    	pre[i] = buf[i] = f[i] = 0;
    T++;
    r.clear();
}

int main()
{
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);

	while (cin >> l >> q)
	{
		if (!l)
			break;
		
		clear();

	   	for (int query = 1; query <= q; query++)
	   	{
	   		cin >> o;
	   		if (o == 1)
	   		{
	   			cin >> n >> d >> v;
	   			if (n % d != 0)
	   				continue;
	   			if (was[d] != T)
	   			{
	   				g[d] = 0;
	   				r.pb(d);
	   				was[d] = T;
	   			}
	   		 	g[d] += v;
	   		 	n /= d;
	   		 	p = 1;
	   		 	while (p * p <= n)
	   		 	{
	   		 		if (n % p == 0)
	   		 		{
	   		 			if (p != 1)
	   		 				upd(p * d, -v);
	   		 			if (n / p != p)
	   		 				upd(n / p * d, -v);
	   		 		}
	   		 		p++;
	   		 	}
	   		}
	   		else
	   		{
	   			cin >> v;
	   			sum = pre[v] + get(v);
	   			for (int i = 0; i < (int)r.size(); i++)
	   				sum += g[r[i]] * (v / r[i]);
	   			cout << sum << "\n";
	   		}

	   		if (0)
	   		{
	   			for (int i = 0; i < (int)r.size(); i++)
	   			{
	   				int to = r[i], s = to;
	   				while (s <= l)
	   				{
	   					buf[s] += g[to];
	   					s += to;
	   				}
	   			}
	   			for (int i = 1; i <= l; i++)
	   			{
	   				buf[i] += buf[i - 1] + get(i) - get(i - 1);
	   				pre[i] += buf[i];
	   			}

	   			for (int i = 1; i <= l; i++)
	   				buf[i] = f[i] = 0;
	   			T++;
	   			r.clear();
	   		}
		}
	}
	return 0;
}


