#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "a"
#define M 2050
#define L 100100
#define K 20
#define mod 998244353
#define long long long

int n, a[M];
ll d[K][M];
ll f[L], r[L], pw[L];

void pre()
{
	pw[0] = 1;
	for (int i = 1; i < L; ++i)
	{
		pw[i] = (2 * pw[i - 1]) % mod;
	}
	
	f[0] = 1;
	for (int i = 1; i < L; ++i)
		f[i] = (i * f[i - 1]) % mod;
	
	r[0] = 1;
	r[1] = 1;
	for (int i = 2; i < L; ++i)
	{
		r[i] = -1 * (mod / i) * r[mod % i];
		r[i] %= mod;
		if (r[i] < 0)
			r[i] += mod;
	}
	
	for (int i = 2; i < L; ++i)
	{
		r[i] = (r[i] * r[i - 1]) % mod;
	}
}

ll cnk(ll n, ll k)
{
	if (k < 0 || k > n)
		return 0;
	ll ans = (f[n] * r[k]) % mod;
	ans = (ans * r[n - k]) % mod;
	return ans;
}

bool read()
{
	scanf("%d", &n);
	if (n == 0)
		return false;
	fill(a, a + M, 0);
	for (int i = 0, x; i < n; ++i)
	{
		scanf("%d", &x);
		a[x]++;
	}
	
	d[0][0] = 1;
	for (int i = 1; i <= 2048; ++i)
		d[0][i] = 0;
	
	for (int j = 0; j <= 11; ++j)
	{
		int cnt = a[1 << j];
		for (int k = 0; k <= 2048; ++k)
		{
			d[j + 1][k] = 0;
			
			
			ll sum = pw[cnt];
			
			for (int l = 0; l <= cnt && (l << j) < k; ++l)
			{
				ll c = cnk(cnt, l);
				d[j + 1][k] += c * d[j][k - (l << j)];
				d[j + 1][k] %= mod;
				sum -= c;
			}
			sum %= mod;
			d[j + 1][k] += d[j][0] * sum;
			d[j + 1][k] %= mod;
		}
		n -= cnt;
	}
	
	ll ans = d[12][2048];
	ans = (ans * pw[n]) % mod;
	if (ans < 0)
		ans += mod;
	cout << ans << "\n";
	return true;
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	pre();
	while (read());
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
