#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long long ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "f"

const int maxn = 550;

struct pt
{
	ld x, y;
	int id;
	
	pt(ld nx = 0, ld ny = 0): x(nx), y(ny) {}
	
	pt operator - (const pt &p) const
	{
		return pt(x - p.x, y - p.y);
	}
	
	ld operator % (const pt &p) const
	{
		return x * p.y - p.x * y;
	}
	
	pt operator + (const pt &p) const
	{
		return pt(x + p.x, y + p.y);
	}
	
	pt operator * (ld k) const
	{
		return pt(x * k, y * k);
	}
	
	ld operator * (const pt &p) const
	{
		return x * p.x + y * p.y;
	}
	
	bool operator < (const pt &p) const
	{
		if (x != p.x) return x < p.x;
		return y < p.y;
	}
};

int n;
int m, ans[maxn];
pt pts1[maxn], pts[maxn];
ll v[maxn];

bool solve()
{
	cin >> m;
	if (m == 0) return false;
	int mx = 0;
	for (int i = 0; i < m; ++i)
	{
		cin >> pts1[i].x >> pts1[i].y >> v[i];
		if (v[i] > v[mx])
			mx = i;
	}
	n = 0;
	for (int i = 0; i < m; ++i)
	{
		if (v[i] == v[mx] && v[i] > 0)
			pts[n] = pts1[i], pts[n].id = i, n++;
		else
			ans[i] = 0;
	}
	vector <pt> up(0);
	vector <pt> down(0);
	sort(pts, pts + n);
	for (int i = 0; i < n; ++i)
	{
		while (sz(up) > 1)
		{
			if ((pts[i] - up[sz(up) - 2]) % (up.back() - up[sz(up) - 2]) >= 0)
				break;
			up.pop_back();
		}
		while (sz(down) > 1)
		{
			if ((pts[i] - down[sz(down) - 2]) % (down.back() - down[sz(down) - 2]) <= 0)
				break;
			down.pop_back();
		}
		up.pb(pts[i]);
		down.pb(pts[i]);
	}
	for (int i = 0; i < sz(up); ++i)
		ans[up[i].id] = 1;
	for (int i = 0; i < sz(down); ++i)
		ans[down[i].id] = 1;
	
	for (int i = 0; i < m; ++i)
		printf("%d", ans[i]);
	printf("\n");
	return true;
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	while (solve());
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
