#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "d"

char tmp[1000];
bool g[1001][1010];
int deg[1001];
bool used[1001];

bool solve()
{
	int n;
	scanf("%d", &n);
	if (n == 0)
		return false;
	for (int i = 0; i < n; ++i)
		deg[i] = 0;
	for (int i = 0; i < n; ++i)
	{
		scanf("%s", tmp);
		used[i] = false;
		for (int j = 0; j < n; ++j)
		{
			g[i][j] = (tmp[j] == '1');
			deg[j] += g[i][j];
		}
	}
	vector <int> res(0);
	for (int it = 0; it < n; ++it)
	{
		int best = -1;
		for (int u = 0; u < n; ++u)
		{
			if (used[u])
				continue;
			if (best == -1 || deg[u] > deg[best])
				best = u;
		}
		used[best] = true;
		res.pb(best);
		for (int u = 0; u < n; ++u)
			if (!used[u] && g[best][u])
				--deg[u];
	}
	reverse(res.begin(), res.end());
	for (int i = 0; i < n; ++i)
		cout << res[i] + 1 << ' ';
	cout << '\n';
	return true;
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	while (solve());
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
