#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

ll getDumb(ll x, ll k) {
	for(ll i = 1; i <= k; i++) {
		ll remain = x % i;
		if(remain != 0) {
			ll add = i - remain;
			x += add;
		}
	}
	return x;
}

ll getSmart(ll x, ll k) {
	const ll BUBEN = 10000;
	ll before = 0, was = 0;
	for(ll i = 1; i <= k; i++) {
		ll remain = x % i;
		if(remain != 0) {
			ll add = i - remain;
			if(add == before) {
				++was;
			} else {
				before = add;
				was = 1;
			}
			if(was >= BUBEN) {
				//cout << "BREAK: " << i << endl;
				ll iRemain = k - i + 1;
				x += iRemain * add;
				break;
			} else {
				x += add;
			}
		}
	}
	return x;
}

bool solve() {
	ll x, k;
	cin >> x >> k;
	if(x == 0 && k == 0) return false;
	cout << getSmart(x, k) << "\n";
	return true;
}

int main() {
	while(solve()) ;
	//ll x, k;
	//cin >> x >> k;
	//cout << getDumb(x, k) << " " << getSmart(x, k) << endl;
	return 0;
}