#pragma comment(linker , "/STACK:128000000")

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(true) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li



void solve() {
	int n;
	cin >> n;
	if(n == 0) exit(0);
	vector<string> s(n);
	vector<int> deg(n);
	for(int i = 0; i < n; ++i) {
		cin >> s[i];
		for(int j = 0; j < n; ++j) {
			if(s[i][j] == '1') {
				++deg[i];
			}
		}
	}
	vector<int> used(n);
	

	for(int it = 0; it < n; ++it) {
		int mx = -1;
		for(int i = 0; i < n; ++i) {
			if(!used[i] && (mx == -1 || deg[i] > deg[mx])) {
				mx = i;
			}
		}
		used[mx]=true;
		cout << mx + 1 << " ";

		for(int i = 0; i < n; ++i) {
			if(s[i][mx] == '1') {
				--deg[i];
			}
		}
	}
	cout << "\n";
}