#pragma comment(linker , "/STACK:128000000")

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(true) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int n;
vector <vector <pair <int, int>> > a;
vector <int> res;

void solve() {
	cin >> n;
	if (n == 0) {
		exit(0);
	}

	a.assign(n, vector <pair <int, int> > (n));
	res.resize(n);

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> a[i][j].first >> a[i][j].second;
		}
	}


	vector <int> str(n);

	//find zero
	for (int i = 0; i < n; ++i) {
		int x = a[i][0].first;
		bool f = true;

		for (int j = 0; j < n; ++j) {
			if (a[i][j].first != x || a[i][j].second != x) {
				f = false;
				break;
			}
		}

		if (f) {
			res[0] = x;
			str[0] = i;
			break;
		}
	}
	/*
	//find one
	for (int i = 0; i < n; ++i) {
		if (i == res[0]) {
			continue;
		}

		set <int> tmp;
		bool f = true;

		for (int j = 0; j < n; ++j) {
			if (a[i][j].first != res[0]) {
				f = false;
				break;
			}
			tmp.insert(a[i][j].second);
		}

		if (f && tmp.size() == n) {
			res[1] = i;
			break;
		}
	}
	*/


	//vector < set <int> > tmp(n);
	vector <vector <int> > tmpp(n);

	vector <int> used(n, 0);
	int TIMER = 12;

	for (int i = 0; i < n; ++i) {
		if (i == str[0]) {
			continue;
		}

		int szz = 0;
		++TIMER;

		for (int j = 0; j < n; ++j) {
			if (used[a[i][j].first] != TIMER) {
				++szz;
			}
			used[a[i][j].first] = TIMER;
		}
		tmpp[szz].push_back(i);
	}

	for (int i = 1; i < n; ++i) {
		str[i] = tmpp[i].back();
	}
	
	int col1;
	for (int i = 0; i < n; ++i) {
		bool f = true;
		
		set <int> tmp1;
		set <int> tmp2;

		for (int j = 0; j < n; ++j) {
			tmp1.insert(a[j][i].first);
			tmp2.insert(a[j][i].second);
		}

		if (tmp1.size() == 1 && tmp2.size() == n) {
			col1 = i;
			break;
		}
	}

	/*
	for (int i = 0; i < n; ++i) {
		cout << str[i] << " ";
	}
	cout << " \n";*/
	

	for (int i = 0; i < n; ++i) {
		cout << a[str[i]][col1].second << " ";
		
		//cout << res[i] << " ";
		
	}
	cout << "\n";
}