#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>

using namespace std;

const int MAX_N = 100005;
const int SZ = 13;
const int MOD = 998244353;

int n, a[MAX_N], w[SZ], dp[SZ][1 << SZ], inv[MAX_N];
vector< int > C[MAX_N];

int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    /*
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
    */

    inv[1] = 1;

    for (int i = 2; i < MAX_N; i++) {
        inv[i] = (MOD - ((long long)(MOD / i) * inv[MOD % i]) % MOD) % MOD;
    }


    while (cin >> n) {
        if (n == 0) {
            break;
        }

        int zero = 0;

        memset(w, 0, sizeof(w));

        for (int i = 0; i < n; i++) {
            cin >> a[i];

            if ((a[i] & (a[i] - 1)) || a[i] == 0 || a[i] > 2048) {
                zero++;
            } else {
                w[__builtin_ctz(a[i])]++;
            }
        }

        dp[0][0] = 1;
        for (int i = 1; i < SZ; i++) {
            int bin = 1;
            for (int j = 0; j <= w[i - 1] && j * (1 << (i - 1)) < 2048; j++) {
                for (int sum = j * (1 << (i - 1)); sum < 2048; sum++) {
                    if (j == 0) {
                        dp[i][sum] = 0;
                    }

                    dp[i][sum] = (dp[i][sum] + (long long)dp[i - 1][sum - j * (1 << (i - 1))] * bin) % MOD;
                }

                bin = ((long long)bin * (w[i - 1] - j)) % MOD;
                bin = ((long long)bin * inv[j + 1]) % MOD;
            }
        }

        int ans = 1;

        for (int i = 0; i < n - zero; i++) {
            ans += ans;

            if (ans >= MOD) {
                ans -= MOD;
            }
        }

        for (int i = 0; i < 2048; i++) {
            ans = (ans - dp[SZ - 1][i] + MOD);

            if (ans >= MOD) {
                ans -= MOD;
            }
        }

        for (int i = 0; i < zero; i++) {
            ans += ans;

            if (ans >= MOD) {
                ans -= MOD;
            }
        }

        cout << ans << endl;
    }

    return 0;
}
