#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <stack>
#include <iomanip>

using namespace std;

string s[555];
int color[555];
pair<int, int> ans[555];
int time;
int n;

bool dfs(int v)
{
	color[v] = 1;
	for(int i = 0; i < n; i++)
	{
		if (s[v][i] == '1')
		{
			if (color[i] == 1)
				return true;
			else if (color[i] == 0)
			{
				if (dfs(i))
					return true;
			}			
		}
	}
	ans[v].first = time++;
}


int main() {
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);
	while (cin >> n)
	{
		getline(cin, s[0]);
		if (n == 0)
			break;
		for(int i = 0; i < n; i++)
		{
			getline(cin, s[i]);
			color[i] = 0;
			ans[i].second = i;
		}
		time = 0;
		bool flag = true;
		for(int i = 0; i < n; i++)
		{
			if (!color[i] == 0)
			{
				if (dfs(i)) {
					flag = false;
					break;
				}
			}
		}
		if (!flag)
		{
			cout << -1 << endl;
		} else {
			sort(ans, ans + n);
			for(int i = 0; i < n; i++)
			{
				cout << ans[i].second + 1<< " ";
			}
			cout << endl;
		}
	}
    /*
    freopen("task.in", "r", stdin);
    freopen("task.out", "w", stdout);
    */

    return 0;
}
