#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

const li MOD = 998244353;

int n;
int a[100100];
int dp[2][2049];
bool is_p[100100];

void solve() {
	scanf("%d", &n);
	for (int i = 1; i <= n; i++)
		scanf("%d", &a[i]);
	if (n == 0)
		exit(0);
	memset(dp, 0, sizeof(dp));
	dp[0][0] = 1;
	for (int ii = 0; ii < n; ii++) {
		int i = ii % 2;
		int i1 = 1 - i;
		memset(dp[i1], 0, sizeof(dp[i1]));
		for (int j = 0; j <= 2048; j++) {
			if (dp[i][j] == 0)
				continue;
			dp[i1][j] = (dp[i1][j] + dp[i][j]) % MOD;
			if (is_p[a[ii + 1]]) {
				int next = j + a[ii + 1];
				if (next > 2048)
					next = 2048;
				dp[i1][next] = (dp[i1][next] + dp[i][j]) % MOD;
			} 
		}
	}
	printf("%lld\n", dp[n % 2][2048]);
	//cerr << dp[n % 2][2048] << '\n';
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int cur = 1;
	while (true) {
		is_p[cur] = true;
		cur *= 2;
		if (cur > 100000)
			break;
	}
	while (true) {
		solve();
	}
}