#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define lint long long
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

lint apply(lint x, lint k) {
	if (x % k == 0) return x;
	return x - (x % k) + k;
}

#define LIM 100000LL


int main()
{
	ios_base::sync_with_stdio(false);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	//int tests = 0; cin >> tests;
	while (1) {
		li x, k; cin >> x >> k;
		if (x + k == 0) break;
		for (int i = 1; i <= min(k, LIM); i++) {
			x = apply(x, i);
		}
		lint i = LIM + 1;
		while (i <= k) {
			lint cc = x / i;
			lint next = (cc == 1) ? k : x / (cc - 1);
			x = apply(x, next);
			i = next + 1;
		}
		cout << x << endl;
	}
}