#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second
#define in(n) int (n) = nxt()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int res;
    scanf("%d", &res);
    return res;
}

long long mod = 998244353;

long long pw(long long a, long long n) {
    long long res = 1;
    while (n) {
        if (n & 1ll) {
            res = res * a % mod;
        }
        a = a * a % mod;
        n >>= 1;
    }
    return res;
}

long long P = 730033;
long long IP;

const int N = 1 << 13;

long long PW[N];
long long IPW[N];
long long RN;

void fft(long long *a, bool inv = false) {

    for (int i = 1, j = 0; i < N; ++i) {
        int bit = N >> 1;
        while (bit <= j) {
            j -= bit;
            bit >>= 1;
        }
        j += bit;
        if (i < j) {
            swap(a[i], a[j]);
        }
    }

    for (int len = 2, shift = N >> 1; len <= N; len <<= 1, shift >>= 1) {
        int len2 = len >> 1;
        for (int i = 0; i < N; i += len) {
            for (int j = 0; j < len2; ++j) {
                long long u = a[i + j];
                long long v = a[i + j + len2] * (inv ? IPW[shift * j] : PW[shift * j]) % mod;

                a[i + j] = (u + v);
                a[i + j + len2] = u - v;
                if (a[i + j] >= mod) {
                    a[i + j] -= mod;
                }
                if (a[i + j + len2] < 0) {
                    a[i + j + len2] += mod;
                }
            }
        }
    }

    if (inv) {
        for (int i = 0; i < N; ++i) {
            a[i] = (a[i] * RN) % mod;
        }
    }
}

void pre() {
    IP = pw(P, mod - 2);
    RN = pw(N, mod - 2);
    PW[0] = IPW[0] = 1;
    for (int i = 1; i < N; ++i) {
        PW[i] = PW[i - 1] * P % mod;
        IPW[i] = IPW[i - 1] * IP % mod;
    }
}

void sq(long long *a) {
    fft(a);
    for (int i = 0; i < N; ++i) {
        a[i] = a[i] * a[i] % mod;
    }
    fft(a, 1);
    for (int i = 2049; i < N; ++i) {
        a[2048] += a[i];
        a[2048] %= mod;
        a[i] = 0;
    }
}

void mul(long long *a, long long *b) {
    fft(a);
    fft(b);
    for (int i = 0; i < N; ++i) {
        a[i] = a[i] * b[i] % mod;
    }
    fft(a, 1);
    fft(b, 1);
    for (int i = 2049; i < N; ++i) {
        a[2048] += a[i];
        a[2048] %= mod;
        a[i] = 0;
    }
}

void pw(long long * a, long long * res, int n) {
    memset(res, 0, N * sizeof(long long));
    res[0] = 1;
    while (n) {
        if (n & 1) {
            mul(res, a);
        }
        sq(a);
        n >>= 1;
    }
}

void test() {
    long long a[N];
    long long b[N];
    memset(a, 0, sizeof(a));
    //memset(b, 0, sizeof(b));
    a[0] = 1, a[1] = 1;
    sq(a);
    sq(a);
    sq(a);
    for (int i = 0; i < 9; ++i) {
        cout << a[i] << " ";
    }

    cout << endl;
    exit(0);
}

void solve(){
    in(n);
    if (!n) exit(0);
    int cnt[2049];
    memset(cnt, 0, sizeof(cnt));
    for (int i = 0; i < n; ++i) {
        in(x);
        if (!(x & (x - 1))) {
            cnt[x]++;
        } else {
            cnt[0]++;
        }
    }
    long long ans[N];
    memset(ans, 0, sizeof(ans));
    //ans[0] = pw(2, cnt[0]);
    ans[0] = 1;
    for (int i = 0; i <= 2048; ++i) {
        if (cnt[i] > 0) {
            long long a[N];
            memset(a, 0, sizeof(a));
            a[0] += 1;
            a[i] += 1;
            long long res[N];
            pw(a, res, cnt[i]);
            //cerr << "ASD " << i << endl;
            mul(ans, res);
        }
    }
    cout << ans[2048] << endl;
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    pre();
    //test();
    while (1) {
        solve();
    }

    return 0;
}
