#include <bits/stdc++.h>

using namespace std;

struct point
{
    int x, y, num, v;
    point(){}
    point(int x, int y): x(x), y(y){}
} g;

point operator - (point a, point b)
{
    return point(a.x - b.x, a.y - b.y);
}

int operator * (point a, point b)
{
    return a.x * b.y - a.y * b.x;
}
int operator % (point a, point b)
{
    return a.x * b.x + a.y * b.y;
}

bool operator < (point a, point b)
{
    return (a - g) * (b - g) < 0 || (a - g) * (b - g) == 0 && (a - g) % (a - g) < (b - g) % (b - g);
}

int main()
{
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    while(cin >> n){
    if(n == 0) return 0;
    point pt[n];
    g = point(0, 0);
    for(int i = 0; i < n; i++)
        cin >> pt[i].x >> pt[i].y >> pt[i].v, pt[i].num = i;
    int mv = 0;
    for(int i = 0; i < n; i++) mv = max(mv, pt[i].v);
    string ans(n, '0');
    int sz = n;
    int cnt = 1;
        for(int i = 1; i < sz; i++)
            if(pt[i].v == mv && pt[i].x < pt[0].x) swap(pt[0], pt[i]);
        g = pt[0];
        sort(pt + 1, pt + sz);
        g = point(0, 0);
        vector<int> st(2);
        st[0] = 0, st[1] = 1;
        st.reserve(sz);
        for(int i = 2; i < sz; i++)
        {
            if(pt[i].v != mv) continue;
            while(st.size() > 1 && pt[i] - pt[st[st.size() - 2]] < pt[st[st.size() - 1]] - pt[st[st.size() - 2]])
                st.pop_back();
            st.push_back(i);
        }
        for(int i = 0; i < st.size(); i++) ans[pt[st[i]].num] = '1';
        cout << ans << "\n";
    }
    return 0;
}
