#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MOD = 998244353; 
const int maxn = 1000000; 
int c[20][maxn]; 
int g[20]; 
int ff[maxn], fr[maxn]; 
int is[5000]; 
int used[20][2500]; 
int mas[20][2500]; 
int ITER; 

inline int multt(ll x, ll y) {
	return x * y % MOD; 
}

const int power(int x, int p) {
	if (p == 0) return 1; 
	if (p % 2) return multt(power(x, p - 1), x); 
	int t = power(x, p / 2); 
	return multt(t, t); 
}

inline int getc(int n, int k) {
	if (k > n || k < 0) return 0; 
	if (n < 0) return 0; 
	return multt(multt(ff[n], fr[n - k]), fr[k]); 
}

int f(int i, int sum) {
	if (sum >= 2048) sum = 2048;
	if (i == 12) {
		return sum == 2048; 
	} 
	if (used[i][sum] == ITER) return mas[i][sum]; 
	used[i][sum] = ITER; 

	int val = (1 << i); 
	int k = (2048 + val - 1) / val; 

	int & res = mas[i][sum]; 
	res = 0; 
	if (k <= g[i]) 
		res = multt(c[i][k], f(i + 1, 2048));
	k = min(k - 1, g[i]); 
	while (k >= 0) {
		res += multt(getc(g[i], k), f(i + 1, sum + val * k)); 
		if (res >= MOD) res -= MOD; 
		k--; 
	}
	return res; 
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	
	ff[0] = 1; 
	fr[0] = power(ff[0], MOD - 2); 
	for (int i = 1; i <= 100000; i++) {
		ff[i] = multt(i, ff[i - 1]); 
		fr[i] = power(ff[i], MOD - 2); 
	}

	for (int i = 0; i <= 11; i++) {
		is[(1 << i)] = i + 1; 
	}

	while (1) {
		int n; 
		scanf("%d", &n); 
		if (!n) break;
		
		for (int i = 0; i < 20; i++) {
			g[i] = 0; 
		}

		int bad = 0; 
		for (int i = 0; i < n; i++) {
			int x; 
			scanf("%d", &x); 
			if (x <= 2048 && is[x]) {
				g[is[x] - 1]++; 
			} else {
				bad++; 
			}
		}

		for (int i = 0; i < 20; i++) {
			c[i][g[i]] = 1; 
			for (int j = g[i] - 1; j >= 0; j--) {
				c[i][j] = c[i][j + 1] + getc(g[i], j); 
				if (c[i][j] >= MOD) c[i][j] -= MOD; 
			}
		}
		
		ITER++; 
		int res = f(0, 0);
		for (int i = 0; i < bad; i++) {
			res = res + res; 
			if (res >= MOD) res -= MOD; 
		}

		printf("%d\n", res); 
	}



	return 0;
}