#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

int p; 
int real_ans[500]; 
int ans[500]; 
int a[500][500]; 
int b[500][500]; 
int cnt[500]; 
bool used[500]; 
int cnt_[500];
map<pii, int> cnt2; 


bool input() {
	scanf("%d", &p); 
	if (!p) return false;
	for (int i = 0; i < p; i++) {
		for (int j = 0; j < p; j++) {
			scanf("%d %d", &a[i][j], &b[i][j]); 
		}	
	}
	return true; 
}

bool input2(int pp) {
	p = rand() % 500;  
	for (int i = 0; i < p; i++) {
		real_ans[i] = i; 
	}
	random_shuffle(real_ans, real_ans + p); 

	for (int i = 0; i < p; i++) {
		for (int j = 0; j < p; j++) {
			a[real_ans[i]][real_ans[j]] = real_ans[i * j / p]; 
			b[real_ans[i]][real_ans[j]] = real_ans[i * j % p]; 
		}
	}
	return 1; 
}

bool cmp(int a, int b){
	return cnt[a] > cnt[b];
}

void countcnt() {
	for (int p = 2; p <= 500; p++) {
		cerr << p << '\n';
		memset(cnt, 0, sizeof(cnt)); 
		cnt2.clear(); 
		for (int i = 0; i < p; i++) {
			for (int j = 0; j < p; j++) {
				cnt[i * j / p]++; 
				cnt[i * j % p]++; 
				cnt2[mp(i * j / p, i * j % p)]++; 
			}
		}
		vector<int> cur; 
		for (map<pii, int>::iterator it = cnt2.begin(); it != cnt2.end(); ++it) {
			cur.pb(it->second); 
		}
		sort(cur.begin(), cur.end()); 
		if (unique(cur.begin(), cur.end()) != cur.end()) {
			cout << p << "\n"; 
		}
		/*sort(cnt, cnt + p); 
		if (unique(cnt, cnt + p) - cnt != p) {
			cout << p << "\n"; 
		}*/

	}
}

bool cmpp(int a, int b) {
	return mp(cnt[a], cnt_[a]) < mp(cnt[b], cnt_[b]); 
}

void solution() {
	for (int i = 0; i < p; i++) {
		ans[i] = i; 
		sort(a[i], a[i] + p); 
		sort(b[i], b[i] + p); 
		cnt[i] = unique(a[i], a[i] + p) - a[i]; 
		cnt_[i] = unique(b[i], b[i] + p) - b[i]; 
	}
	
	sort(ans, ans + p, cmpp); 

	for(int i = 0; i < p; i++) {
		printf("%d ", ans[i]); 
	}
	puts(""); 




	/*memset(ans, 0, sizeof(ans)); 
	memset(cnt, 0, sizeof(cnt)); 
	memset(used, 0, sizeof(used));
	for (int i = 0; i < p; i++) {
		for (int j = 0; j < p; j++) {
			cnt[a[i][j]]++; 
			cnt[b[i][j]]++; 
		}
	}

	int ind = 0; 
	for (int i = 0; i < p; i++) {
		if (cnt[i] > cnt[ind]) ind = i; 
	}
	add(0, 1);
	for (int i = 1; i < p; i++) {
		int memcnt = -1, memind = 0; 
		for (int ii = 0; ii < p; ii++) {
			if (used[ii]) continue; 
			bool ok = 1; 
			int cnt = 0; 
			for (int j = 0; j < p; j++) {
				if (!used[a[ii][j]]) ok = 0;  
				if (!used[a[j][ii]]) ok = 0; 
			}
			if (ok) {
				ans[i] = ii; 
				used[ii] = 1; 
				break; 
			} 
		}
	}*/

	/*for (int i = 3; i < p; i++) {
		for (int k = 2; k < p; k++) {
			int z = k * i; 
			int aa = z / p; 
			int bb = z % p; 
			if (aa < i && bb < i) {
				//ans[i] = pos[mp(aa, bb)]; 
			}
		}
	}*/
}

bool check() {
	for (int i = 0; i < p; i++) {
		if (ans[i] != real_ans[i]) return false;
	}
	return true; 
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false);

	/*countcnt(); 
	return 0; */

	int iter = 10000; 
	int pp = 2; 
	while (1) {
		if (!input()) break; 
		solution();
		continue;
		//cout << pp << " "; 
		//pp++; 
		if (!check()) {
			cout << "WA\n"; 
			for (int i = 0; i < p; i++) {
				for (int j = 0; j < p; j++) {
					cout << a[i][j] << " " << b[i][j] << " "; 
				}
				cout << "\n"; 
			}

			for (int i = 0; i < p; i++) {
				cout << ans[i] << " "; 
			}
			cout << '\n'; 
			for (int i = 0; i < p; i++) {
				cout << real_ans[i] << " "; 
			}
			cout << '\n'; 

			cout << "WA\n";
			return 1; 
		}
	}

	return 0;
}