#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

const int N = 505;
int pos[N];

int A[N][N], B[N][N];

int cnta[N];

int p;

void stup()
{
	if (A[0][0] == 0)
		printf("0 1\n");
	else
		printf("1 0\n");
	return;
}

bool solve()
{
	scanf("%d", &p);
	if (!p)
		return false;
	for (int i = 0; i < p; i++)
	{
		for (int j = 0; j < p; j++)
			scanf("%d %d", &A[i][j], &B[i][j]);
	}
	if (p == 2)
	{
		stup();
		return true;
	}
	memset(pos, -1, sizeof(int) * p);
	for (int i = 0; i < p; i++)
	{
		int mxa = *max_element(A[i], A[i] + p);
		int mxb = *max_element(B[i], B[i] + p);
		int mna = *min_element(A[i], A[i] + p);
		int mnb = *min_element(B[i], B[i] + p);
		if (mxa == mna && mxa == mxb && mna == mnb)
			pos[0] = i;
	}
	assert(pos[0] != -1);
	memset(cnta, 0, sizeof(int) * p);
	for (int i = 0; i < p; i++)
		for (int j = 0; j < p; j++)
			cnta[A[i][j]]++;
	int cnt1 = 0;
	for (int i = 0; i < p; i++)
		cnt1 += cnta[i] == 1;
	assert(cnt1 == 1);
	for (int i = 0; i < p; i++)
		if (cnta[i] == 1)
			pos[p - 2] = i;
	assert(pos[p - 2] != -1);
	for (int i = 0; i < p; i++)
		for (int j = 0; j < p; j++)
			if (cnta[A[i][j]] == 1)
			{
				assert(i == j);
				pos[1] = B[i][j];
				pos[p - 1] = B[pos[1]][j];
			}
	assert(pos[1] != -1);
	for (int i = p - 3; i > 1; i--)
		pos[i] = A[pos[i + 1]][pos[p - 1]];
	for (int i = 0; i < p; i++)
		printf("%d ", pos[i]);
	printf("\n");
	return true;
}

void gen()
{
	freopen("G2.in", "w", stdout);
	printf("2\n");
	int P[10];
	for (int i = 0; i < 2; i++)
		P[i] = i;
	swap(P[0], P[1]);
	int IP[10];
	for (int i = 0; i < 2; i++)
		IP[P[i]] = i;
	for (int i = 0; i < 2; i++)
	{
		for (int j = 0; j < 2; j++)
			printf("%d %d ", IP[P[i] * P[j] / 10], IP[P[i] * P[j] % 10]);
		printf("\n");
	}
	printf("0\n");
}

int main() {
	//gen();
#ifdef LOCAL42
#define TASK "G"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	while (solve());
	return 0;
}
