#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;
const double EPS = 1e-8;

int n;
int x[512], y[512], v[512];
char inf[512];

void test() {
  FOR(i, 0, n) cin >> x[i] >> y[i] >> v[i];
  int mx = 0;
  FOR(i, 0, n) mx = max(mx, v[i]);
  memset(inf, 0, sizeof inf);
  FOR(i, 0, n) {
    inf[i] = '0';
    if (v[i] == mx && mx) {
      bool ok = true;
      vector<double> angles;
      FOR(j, 0, n) {
        if (j == i) continue;
        if (x[i] == x[j] && y[i] == y[j] && v[j] == mx) {
          ok = false;
          break;
        }
        angles.push_back(atan2(y[j] - y[i], x[j] - x[i]));
      }
      if (ok) {
        if (angles.size()) {
          sort(angles.begin(), angles.end());
          if (angles.back() - angles[0] > PI + EPS) {
            ok = false;
            FOR(j, 1, angles.size()) {
              if (angles[j] - angles[j - 1] > PI - EPS) {
                ok = true;
                break;
              }
            }
          }
        }
      }
      if (ok) {
        inf[i] = '1';
      }
    }
  }
  cout << inf << '\n';
}

int main() {
  while (true) {
    cin >> n;
    if (n == 0) break;
    test();
  }
  return 0;
}
