#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

int perm[512];

void test(int p) {
  FOR(i, 0, p) {
    set<int> x;
    set<int> y;
    FOR(j, 0, p) {
      int a, b;
      scanf("%d%d", &a, &b);
      x.insert(a);
      y.insert(b);
    }
    int val;
    if (x.size() == 1 && y.size() == 1 && *x.begin() == *y.begin()) {
      val = 0;
    } else {
      val = x.size();
    }
    perm[val] = i;
  }
  FOR(i, 0, p) printf("%d ", perm[i]);
  printf("\n");
}

int main() {
  while (true) {
    int p;
    scanf("%d", &p);
    if (p == 0) break;
    test(p);
  }
  return 0;
}
