#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

int main() {
  while (true) {
    LL x, y;
    cin >> x >> y;
    if (x == 0 && y == 0) break;
    LL step = 1;
    while (step <= y && x != step * (step + 1)) {
      x = ((x + step - 1) / step) * step;
      step++;
    }
    if (y > step) {
      x = y * step;
    }
    cout << x << "\n";
  }
  return 0;
}
