#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

int main() {
  while (true) {
    LL x, y;
    cin >> x >> y;
    if (x == 0 && y == 0) break;
    LL step = 0;
    while (step < y && step <= 1) {
      LL prev = x;
      step++;
      x = ((x + step - 1) / step) * step;
//      cout << step << ": " << x << " " << x / step << endl;
    }
    while (step < y) {
      LL r = x / step;
      step += 1;
      x = ((x + step - 1) / step) * step;
      LL r2 = x / step;
      if (r2 < r) {
        r -= r2;
        LL fwd = min(max((r2 - r * (step + 1)) / (2 * r), 0LL), y - step);
        step += fwd;
        x = step * (r2 - r * fwd);
      } else if (r2 == r) {
        step = y;
        x = step * r2;
      }
    }
    cout << x << "\n";
//    for (auto &x : st) {
//      cout << x << ' ';
//    }
//    cout << endl;
  }
  return 0;
}
