#include <iostream>
#include <bitset>
#include <vector>
using namespace std;

const int maxn = 500;

bitset<maxn> vc[maxn];
bitset<maxn> rvc[maxn];
bitset<maxn> new_vc[maxn];

int main() {
    ios_base::sync_with_stdio(false);
    while(1)
    {
        int n;
        cin >> n;
        if(!n)
            break;
        for(int i = 0; i < n; ++i)
            for(int j = 0; j < n; ++j)
            {
                char t;
                cin >> t;
                vc[i][j] = t - '0';
                rvc[j][i] = t - '0';
            }
        /*for(int i = 0; i < n; ++i)
        {
            for(int j = 0; j < n; ++j)
                cout << rvc[i][j] << " ";
            cout << endl;
        }*/
        for(int i = 0; i < n; ++i)
            for(int j = 0; j < n; ++j)
                if(i != j)
                {
                    new_vc[i][j] = (vc[i] & rvc[j]).any();
                    if(vc[i][j])
                        new_vc[i][j] = 1;
                }
        /*for(int i = 0; i < n; ++i)
        {
            for(int j = 0; j < n; ++j)
                cout << new_vc[i][j] << " ";
            cout << endl;
        }*/
        int need = n - 1;
        vector <int> ans;
        vector <char> used(n, 0);
        for(int tt = 0; tt < n; ++tt)
        {
            int ans_pos = -1;
            for(int i = 0; i < n; ++i)
                if(new_vc[i].count() == need && !used[i])
                {
                    ans_pos = i;
                    break;
                }
            if(ans_pos == -1)
                break;
            used[ans_pos] = 1;
            for(int i = 0; i < n; ++i)
                new_vc[i][ans_pos] = 0;
            ans.push_back(ans_pos);
            --need;
        }
        if(ans.size() != n)
            cout << "-1" << endl;
        else
        {
            for(int i = 0; i < ans.size(); ++i)
                cout << ans[i] + 1 << " ";
            cout << endl;
        }
    }
    return 0;
}
