#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

ll get(ll multy, ll num)
{
	ll v = (num / multy) + ((num % multy) != 0);
	return multy * v;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
	ll x, k;

	while (cin >> x >> k)
	{
		if (x == 0) break;

		ll step = 0;
		ll w = 0;
		for (ll i = 1; i * i <= x * 5; i++)
		{
			if (i > k) break;
			step = i;
			w = get(i, x) - x;
			x += w;
		}

		if (step < k)
			x += w * (k - step);

		/*for (int i = 1; i <= k; i++)
		{
			cout << i << ":" << get(i, x) - x << endl;
			x = get(i, x);
		}*/
		cout << x << endl;
	}

    return 0;
}