#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

int p;
map < li, int > v, v2;
int cnt[505][3];
li cnthash[505];
int a[505][505], b[505][505];
vector <int> vs[505];
li hh[505];

li hs(int id) {
	li res = 0;
	forn(i, 3) {
		res *= p * p;
		res += cnt[id][i];
	}
	return res;
}

int hs2(vector <int>& v) {
	li res = 0;
	forn(i, sz(v)) {
		res = (res * p + v[i]) % 1000000007;
	}
	return res;
}

bool read() {
	if (scanf("%d", &p) != 1)
		return false;

	if (p == 0)
		return false;

	return true;
}

void calc() {
	v.clear();
	memset(cnt, 0, sizeof(cnt));
	forn(i, p)
		vs[i].clear();

	forn(i, p)
		forn(j, p) {
			int x = a[i][j];
			int f = x / p;
			int s = x % p;

			if (f != s) {
				cnt[f][0]++;
				cnt[s][1]++;
			} else
				cnt[f][2]++;
		}

	int x = 0;

	forn(i, p) {
		cnthash[i] = hs(i);
		v[cnthash[i]]++;
	}

	int m = 0;
	for (map <li, int> :: iterator it = v.begin(); it != v.end(); ++it)
		it->sc = m++;
	
	forn(i, p)
		cnthash[i] = v[ cnthash[i] ];

	forn(i, p)
		forn(j, p) {
			int x = a[i][j];
			int f = x / p;
			int s = x % p;

			vs[f].pb(cnthash[s]);
		}

	v.clear();
	forn(i, p) {
		sort(all(vs[i]));
		vs[i].pb(cnthash[i]);
		hh[i] = hs2(vs[i]);
		v[ hh[i] ] = i;
	}
}

void solve() {

	forn(i, p)
		forn(j, p) {
			a[i][j] = 0;
			forn(t, 2) {
				int d;
				scanf("%d", &d);
				a[i][j] = a[i][j] * p + d;
			}
		}

	calc();
	map <li, int> v2 = v;

	forn(i, p)
		forn(j, p)
			a[i][j] = i * j;

	calc();

	forn(i, p)
		printf("%d ", v2[hh[i]]);
	puts("");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while(read())
	solve();

	return 0;
}