#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
#define MOD 998244353
using namespace std;
int T, n, v[100100], nr[2100][2100], fact[100100], inv[100100], rest, total[2100], loga[2100];
int sol, now;

inline int LgPut(int baz, int put)
{
    int rez = 1;
    while(put > 0)
    {
        if(put % 2 == 1)
        {
            rez = (1LL * rez * baz) % MOD;
            put--;
        }
        baz = (1LL * baz * baz) % MOD;
        put /= 2;
    }
    return rez;
}

inline int Comb(int i, int j)
{
    if(i == j)
        return 1;
    if(i < j)
        return 0;
    int rez = fact[i];
    rez = (1LL * rez * inv[j]) % MOD;
    rez = (1LL * rez * inv[i - j]) % MOD;
    return rez;
}

int main ()
{
#ifdef local
    freopen ("a.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, j, k;
    //fact[0] = 1; inv[0] = 1;
    for(i = 1; i <= 100010; ++i)
    {
        //fact[i] = (1LL * i * fact[i - 1]) % MOD;
        inv[i] = LgPut(i, MOD - 2);
    }
    while(1)
    {
        cin >> n;
        if(n == 0)
            break;
        for(j = 1; j <= 2048; j *= 2)
            for(i = 0; i <= 2048; ++i)
                nr[j][i] = 0;

        memset(total, 0, sizeof(total));
        sol = 0;
        for(i = 1; i <= n; ++i)
        {
            cin >> v[i];
            if(v[i] <= 2048)
                total[v[i]]++;
        }
        rest = n;
        for(i = 1; i <= 2048; i *= 2)
            rest -= total[i];
        for(i = 1; i <= 2048; i *= 2)
        {
            nr[i][0] = 1;
            for(j = 2048; j >= 0; --j)
            {
                if(j == 2)
                {
                    j++;
                    j--;
                }
                //nr[i][j] += nr[i][j + 1];
                if(nr[i][j] >= MOD)
                    nr[i][j] -= MOD;
                if(i * 2 <= 2048 && nr[i][j] )
                {
                    int comb = 1;
                    k = 0;
                    nr[2 * i][(j + k) / 2] += (1LL * nr[i][j] * Comb(total[i], k)) % MOD;
                    if(nr[2 * i][(j + k) / 2] >= MOD)
                        nr[2 * i][(j + k) / 2] -= MOD;
                    for(k = 1; k <= total[i]; ++k)
                    {
                        comb = (1LL * comb * (total[i] - k + 1)) % MOD;
                        comb = (1LL * comb * inv[k]) % MOD;
                        nr[2 * i][min((j + k) / 2, 2048)] += (1LL * nr[i][j] * comb) % MOD;
                        if(nr[2 * i][min((j + k) / 2, 2048)] >= MOD)
                            nr[2 * i][min((j + k) / 2, 2048)] -= MOD;
                    }
                }
            }
        }
        sol = 0;
        for(i = 1; i <= 2048; ++i)
        {
            sol += nr[2048][i];
            if(sol >= MOD)
                sol -= MOD;
        }

        sol = (1LL * sol * LgPut(2, rest)) % MOD;
        cout << sol << "\n";
    }
    return 0;
}
