#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>

using namespace std;
int n, X[510], Y[510], V[510], maxim;
char sol[510];

int main ()
{
#ifdef local
    freopen ("b.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, j;
    bool gasit[4];
    while(1)
    {
        cin >> n;
        if(n == 0)
            break;
        maxim = 0;
        for(i = 1; i <= n; ++i)
        {
            cin >> X[i] >> Y[i] >> V[i];
            sol[i] = '1';
            maxim = max(maxim, V[i]);
        }
        sol[n + 1] = 0;

        for(i = 1; i <= n; ++i)
        {
            gasit[0] = gasit[1] = gasit[2] = gasit[3] = false;
            for(j = 1; j <= n; ++j)
            {
                if(i == j || V[j] < maxim)
                    continue;
                if(X[j] < X[i])
                    gasit[0] = true;
                if(X[j] > X[i])
                    gasit[1] = true;
                if(Y[j] < Y[i])
                    gasit[2] = true;
                if(Y[j] > Y[i])
                    gasit[3] = true;
            }
            if(V[i] != maxim)
                sol[i] = '0';
            if(gasit[0] && gasit[1])
                sol[i] = '0';
            if(gasit[2] && gasit[3])
                sol[i] = '0';
        }

        cout << (sol + 1) << "\n";
    }
    return 0;
}
