#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
#define pii pair<int, int>
using namespace std;
int n;
long long  X[510], Y[510], V[510];
char sol[510];
bool atins[510][5];

long long Dist(long long a, long long b, long long c, long long d)
{
    return ((a - c) * (a - c) + (b - d) * (b - d));
}

int main ()
{
#ifdef local
    freopen ("b.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, j;
    bool gasit[4];
    while(1)
    {
        cin >> n;
        if(n == 0)
            break;
        for(i = 1; i <= n; ++i)
        {
            cin >> X[i] >> Y[i] >> V[i];
            sol[i] = '1';
        }
        sol[n + 1] = 0;
        memset(atins, false, sizeof(atins));
        for(i = 1; i <= n; ++i)
        {
            for(j = 1; j <= n; ++j)
            {
                if(i == j)
                    continue;
                if(Dist(X[i], Y[i], X[j], Y[j]) <= 10050LL * 10050LL * V[i] * V[i])
                    atins[j][0] = true;
                if(Dist(X[i], Y[i], X[j] + 10050 * V[j], Y[j]) <= 10050LL * 10050LL * V[i] * V[i])
                    atins[j][1] = true;
                if(Dist(X[i], Y[i], X[j], Y[j] + 10050 * V[j]) <= 10050LL * 10050LL * V[i] * V[i])
                    atins[j][2] = true;
                if(Dist(X[i], Y[i], X[j] - 10050 * V[j], Y[j]) <= 10050LL * 10050LL * V[i] * V[i])
                    atins[j][3] = true;
                if(Dist(X[i], Y[i], X[j], Y[j] - 10050 * V[j]) <= 10050LL * 10050LL * V[i] * V[i])
                    atins[j][4] = true;
            }
        }
        for(i = 1; i <= n; ++i)
        {
            if(atins[i][0] && atins[i][1] && atins[i][2] && atins[i][3] && atins[i][4])
                sol[i] = '0';
            if(V[i] == 0)
                sol[i] = '0';
        }

        cout << (sol + 1) << "\n";
    }
    return 0;
}
