#include <stdio.h>
#include <string.h>
#include <math.h>

#include <algorithm>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <iostream>
#include <bitset>

using namespace std;
int n, nrrad, R;
vector <int> G[510], sol;
bitset <510> B[510];
bool rad[510];

inline void DFS(int x)
{
    B[x][x] = 1;
    vector <int>::iterator it;
    for(it = G[x].begin(); it != G[x].end(); ++it)
    {
        if(B[*it][*it] == 0)
            DFS(*it);
        B[x] = (B[x] | B[*it]);
    }
}

int main ()
{
#ifdef local
    freopen ("d.in", "r", stdin);
    freopen ("", "w", stdout);
#endif
    int i, j;
    char s[510];
    while(1)
    {
        cin >> n;
        if(n == 0)
            break;
        for(i = 1; i <= n; ++i)
            rad[i] = true;
        for(i = 1; i <= n; ++i)
        {
            cin >> (s + 1);
            for(j = 1; j <= n; ++j)
            {
                if(s[j] == '1')
                {
                    G[j].push_back(i);
                    rad[i] = false;
                }
            }
        }
        nrrad = 0;
        for(i = 1; i <= n; ++i)
        {
            if(rad[i])
            {
                R = i;
                nrrad++;
            }
        }
        if(nrrad != 1)
            cout << "-1\n";
        else
        {
            DFS(R);
            sol.clear();
            sol.push_back(R);
            for(i = n - 1; i >= 0; --i)
            {
                for(j = 1; j <= n; ++j)
                {
                    if(B[j].count() == i)
                    {
                        sol.push_back(j);
                        j = n + 1;
                    }
                }
            }
            if(sol.size() != n)
                cout << "-1\n";
            else
            {

                for(i = n - 1; i >= 0; --i)
                    cout << sol[i] << ' ';
                cout << "\n";
            }
        }


        for(i = 1; i <= n; ++i)
        {
            G[i].clear();
            B[i].reset();
            rad[i] = true;
        }
    }
    return 0;
}
