#include <iostream>
#include <ctime>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

const int N = 1111;

int x[N], y[N], v[N], used[N], found, tx[N], ty[N];
int cv;
char ans[N];
int n, mn;
pair<int, int> vv[N];

bool cmp(pair<int, int> u, pair<int, int> v) {
	int eu, ev;
	if (u.second > 0) eu = 1; else
	if ((u.second == 0) && (u.first > 0)) eu = 1; else
	eu = -1;
	if (v.second > 0) ev = 1; else
	if ((v.second == 0) && (v.first > 0)) ev = 1; else
	ev = -1;
	if (eu != ev) return eu < ev;
	int ww = u.first * v.second - v.first * u.second;
	return ww > 0;
} 

int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d", &n);
	while (n > 0) {
		mn = -1;
		for (int i = 0; i < n; i++) {
			scanf("%d%d%d", &x[i], &y[i], &v[i]);
			tx[i] = x[i];
			ty[i] = y[i];
			x[i] += x[i];
			y[i] += y[i];
			if (v[i] > mn) mn = v[i];
		}
		for (int i = 0; i < n; i++) ans[i] = '?';
		for (int i = 0; i < n; i++) {
			if (ans[i] != '?') continue;
			if ((v[i] != mn) || (v[i] == 0)) {
				ans[i] = '0';
				continue;
			}
			bool flag = false;
			for (int j = i + 1; j < n; j++) {
				if ((x[j] == x[i]) && (y[j] == y[i])) {
					ans[j] = '0';
					flag = true;
				}
			}
			if (flag) {
				ans[i] = '0';
				continue;
			}
			cv = 0;
			for (int j = 0; j < n; j++) {
				if ((j == i) || (v[j] != mn)) continue;
				int x0 = (tx[i] + tx[j]);
				int y0 = (ty[i] + ty[j]);
				int vx = y[j] - y[i];
				int vy = x[i] - x[j];
				int ww = (vx * (y[i] - y0) - vy * (x[i] - x0));
				if (ww > 0) {
					vx *= -1;
					vy *= -1;
				}
				vv[cv++] = make_pair(vx, vy);
			}
			sort(vv, vv + cv, cmp);
			//for (int i = 0; i < cv; i++) printf("%d %d\n", vv[i].first, vv[i].second);
			bool found = true;
			int cnt = 0;
			for (int ii = 0; ii < cv; ii++) {
				int j = ii + 1;
				if (j >= cv) j = 0;
				int ev = vv[ii].second > 0 || (vv[ii].second == 0 && vv[ii].first > 0);
				int eu = vv[j].second > 0 || (vv[j].second == 0 && vv[j].first > 0);
				if ((vv[ii].first * vv[j].second == vv[j].first * vv[ii].second) && (eu == ev)) continue;
				cnt++;
				int ww = vv[ii].first * vv[j].second - vv[j].first * vv[ii].second;
				if (ww <= 0) {
					found = false;
					break;
				}
			}
			if (found) ans[i] = '0';
			else ans[i] = '1';
		}
		puts(ans);
		scanf("%d", &n);
	}
	//cerr << clock() << endl;
}
