#include <stdio.h>
#include <algorithm>
#include <iostream>
#include <string.h>
#include <vector>

using namespace std;

const int maxn = 10;
const unsigned char inf = 250;


unsigned char dp[maxn + 3][maxn][1 << maxn][1 << maxn];

int n, m;
char a[maxn][maxn + 1];

void go(unsigned char &a, unsigned char b) {
	if (a > b) {
		a = b;
	}
}

void go(int j, int i, int mask1, int mask2) {
	int toDelete = mask1 & (1 << i);

	int nj = j;
	int ni = i + 1;
	if (ni == n) {
		ni = 0;
		nj++;
	}
	int nmask1 = mask1;
	nmask1 &= (1 << n) - 1 - (1 << i);
	nmask1 |= mask2 & (1 << i);
	
	int nmask2 = mask2;
	nmask2 &= (1 << n) - 1 - (1 << i);
	nmask2 |= (a[i][j] - '0') * (1 << i);

	if (toDelete == 0) {
		int nnmask1 = nmask1;
		int nnmask2 = nmask2;
		go(dp[nj][ni][nnmask1][nnmask2], dp[j][i][mask1][mask2] + 0);
	}
	if (toDelete != 0) {
		int nnmask1 = nmask1;
		int nnmask2 = nmask2;
		if (i > 0) {
			nnmask1 ^= (1 << (i - 1));
		}
		if (i + 1 < n) {
			nnmask2 ^= (1 << (i + 1));
		}
		nnmask2 ^= 1 << i;
		go(dp[nj][ni][nnmask1][nnmask2], dp[j][i][mask1][mask2] + 1);
	}
	if (toDelete != 0) {
		int nnmask1 = nmask1;
		int nnmask2 = nmask2;
		if (i > 0) {
			nnmask1 ^= (1 << (i - 1));
		}
		if (i + 1 < n) {
			nnmask2 ^= (1 << (i + 1));
		}
		nnmask2 ^= 1 << i;
		nnmask1 ^= 1 << i;
		go(dp[nj][ni][nnmask1][nnmask2], dp[j][i][mask1][mask2] + 1);
	}
	if (toDelete == 0) {
		int nnmask1 = nmask1;
		int nnmask2 = nmask2;
		nnmask1 ^= 1 << i;
		go(dp[nj][ni][nnmask1][nnmask2], dp[j][i][mask1][mask2] + 2);		
	}
}

int main() {
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	
	while (1) {
		cin >> n >> m;
		if (!n && !m) break;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				cin >> a[i][j];
			}
			a[i][m] = '0';
		}

		for (int j = 0; j <= m + 2; j++) {
			for (int i = 0; i < n; i++) {
				for (int mask1 = 0; mask1 < 1 << n; mask1++) {
					for (int mask2 = 0; mask2 < 1 << n; mask2++) {
						dp[j][i][mask1][mask2] = inf;
					}
				}
			}
		}
		int mask0 = 0;
		for (int i = 0; i < n; i++) mask0 |= (a[i][0] - '0') << i;
		for (int mask1 = 0; mask1 < 1 << n; mask1++) {
			dp[1][0][mask1][mask0] = 0;
		}

		for (int j = 1; j <= m; j++) {
			for (int i = 0; i < n; i++) {
				for (int mask1 = 0; mask1 < 1 << n; mask1++) {
					for (int mask2 = 0; mask2 < 1 << n; mask2++) {
						if (dp[j][i][mask1][mask2] == inf) continue;
						go(j, i, mask1, mask2);
					}
				}
			}
		}
		unsigned char mx = inf;
		for (int mask2 = 0; mask2 < 1 << n; mask2++) {
			mx = min(mx, dp[m + 1][0][0][mask2]);
		}
		cout << (int)mx << endl;
	}

	return 0;
}
