#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

LL x, k, res;
LL a[200001];

void readin(){
    cin >> x >> k;
}

void init(){
    a[0] = x;
    int i = 0;
    while (true){
        i++;
        if (a[i - 1] % i == 0) a[i] = a[i - 1];
        else a[i] = a[i - 1] + i - a[i - 1] % i;
        if (i == k || i > 100000 && a[i] - a[i - 1] == a[i - 1] - a[i - 2]) break;
    }

    if (i >= k) res = a[i];
    else res = a[i] + (k - i) * (a[i] - a[i - 1]);
}

void solve()
{
    while (true){
        readin();
        if (x == 0) break;
        init();
        cout << res << endl;
    }
}

void make(){
    freopen("output.txt", "w", stdout);
    for (int i = 1; i <= 510; i++)
        cout << "10000000000 10000000000" << endl;
    cout << "0 0" << endl;
    exit(0);
}

int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
    //freopen("output.txt", "r", stdin); // freopen("output.txt", "w", stdout);
    //make();
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif